;CodeVisionAVR C Compiler V1.24.0 Standard
;(C) Copyright 1998-2003 HP InfoTech s.r.l.
;http://www.hpinfotech.ro
;e-mail:office@hpinfotech.ro

;Chip type           : AT90S8535
;Clock frequency     : 4,000000 MHz
;Memory model        : Small
;Optimize for        : Size
;(s)printf features  : int, width
;(s)scanf features   : long, width
;External SRAM size  : 0
;Data Stack size     : 128 byte(s)
;Heap size           : 0 byte(s)
;Promote char to int : No
;char is unsigned    : Yes
;8 bit enums         : Yes
;Automatic register allocation : On

	.DEVICE AT90S8535
	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU RAMPZ=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x40
	.EQU __sm_mask=0x30
	.EQU __sm_powerdown=0x20

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	CLR  R30
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@2,@0+@1
	.ENDM

	.MACRO __GETWRMN
	LDS  R@2,@0+@1
	LDS  R@3,@0+@1+1
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __GETB1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETW1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOV  R30,R0
	MOV  R31,R1
	.ENDM

	.MACRO __GETB2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOV  R26,R0
	MOV  R27,R1
	.ENDM

	.MACRO __GETBRSX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTBSRX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "asc.vec"
	.INCLUDE "asc.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	LDI  R31,0x10
	OUT  WDTCR,R31

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x200)
	LDI  R25,HIGH(0x200)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM
	ADIW R30,1
	MOV  R1,R0
	LPM
	ADIW R30,1
	MOV  R22,R30
	MOV  R23,R31
	MOV  R31,R0
	MOV  R30,R1
	SBIW R30,0
	BREQ __GLOBAL_INI_END
	LPM
	ADIW R30,1
	MOV  R26,R0
	LPM
	ADIW R30,1
	MOV  R27,R0
	LPM
	ADIW R30,1
	MOV  R24,R0
	LPM
	ADIW R30,1
	MOV  R25,R0
__GLOBAL_INI_LOOP:
	LPM
	ADIW R30,1
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOV  R30,R22
	MOV  R31,R23
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x25F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x25F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0xE0)
	LDI  R29,HIGH(0xE0)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0xE0
;       1 /*********************************************
;       2 This program was produced by the
;       3 CodeWizardAVR V1.24.0 Light
;       4 Automatic Program Generator
;       5  Copyright 1998-2003 HP InfoTech s.r.l.
;       6 http://www.hpinfotech.ro
;       7 e-mail:office@hpinfotech.ro
;       8 
;       9 Project : PPE Ascenseur 2006/2007
;      10 Version : 0.2
;      11 Date    : 19/02/2007
;      12 Author  : TOUZET / PETITJEAN / MOREUX
;      13 Company : Lycee Pierre-Emile MARTIN
;      14 Comments: 
;      15 Programme PPE Ascenseur
;      16 2006 / 2007
;      17 
;      18 
;      19 Chip type           : AT90S8535
;      20 Clock frequency     : 4,000000 MHz
;      21 Memory model        : Small
;      22 External SRAM size  : 0
;      23 Data Stack size     : 128
;      24 *********************************************/
;      25 
;      26 // Chargement des librairies
;      27 #include <90s8535.h>    // librairie C ATMEL AT90S8535
;      28 #include <delay.h>      // Fonction delai
;      29 //#include <tpavnum.h> 	// Table de transcodage du clavier numrique utilis
;      30 #include <ssi.h> 	// SP de dcodage de la trame issue du clavier PS2 et SP Afficheur LCD
;      31 //#include <pavenum.h>    // Gestion d'un clavier numrique type PS2
;      32 #include <stdio.h>	// Fonctions standard entres / sorties
;      33 
;      34 // I2C Bus functions
;      35 #asm
;      36    .equ __i2c_port=0x12
   .equ __i2c_port=0x12
;      37    .equ __sda_bit=3
   .equ __sda_bit=3
;      38    .equ __scl_bit=7
   .equ __scl_bit=7
;      39 #endasm

;      40 #include <i2c.h>
;      41 
;      42 // Afficheur LCD
;      43 #asm
;      44    .equ __lcd_port=0x15
   .equ __lcd_port=0x15
;      45 #endasm

;      46 #include <lcd.h>
;      47 
;      48 /*--------------------------------------------------------------------------------------------------------------------------
;      49 type 			Dsignation				      Commentaires		       
;      50 ----------------------------------------------------------------------------------------------------------------------------*/ 
;      51 char display_buffer_ligne0[17]; 	   // tampon ligne 0 de l'afficheur
_display_buffer_ligne0:
	.BYTE 0x11
;      52 char display_buffer_ligne1[17]; 	   // tampon ligne 1 de l'afficheur
_display_buffer_ligne1:
	.BYTE 0x11
;      53 char display_buffer_ligne2[17]; 	   // tampon ligne 2 de l'afficheur
_display_buffer_ligne2:
	.BYTE 0x11
;      54 char display_buffer_ligne3[17]; 	   // tampon ligne 3 de l'afficheur
_display_buffer_ligne3:
	.BYTE 0x11
;      55 unsigned char EL1, EL2, EL3;		   // Etat des lectro-aimants
;      56 
;      57 // Programme d'interruption
;      58 interrupt [EXT_INT0] void ext_int0_isr(void)
;      59 {

	.CSEG
_ext_int0_isr:
	RCALL __SAVEISR
;      60 
;      61 //interrption INT0  cabler entre la carte SSI et la carte interface I2C
;      62 
;      63 }
	RCALL __LOADISR
	RETI
;      64  
;      65 // Adresse CGRAM de l'afficheur LCD
;      66 #define Add_Caract0_CGRAM 0x40             //caractre 0
;      67 #define Add_Caract1_CGRAM 0x48		   //caractre 1
;      68 #define Add_Caract2_CGRAM 0x50             //caractre 2
;      69 #define Add_Caract3_CGRAM 0x58             //caractre 3
;      70 #define Add_Caract4_CGRAM 0x60             //caractre 4
;      71 #define Add_Caract5_CGRAM 0x68             //caractre 5
;      72 #define Add_Caract6_CGRAM 0x70             //caractre 6
;      73 #define Add_Caract7_CGRAM 0x78             //caractre 7
;      74 
;      75 // Adresses des Ports I2C
;      76 #define AD_BASE_PCF8574		0x40       // base I2C
;      77 #define AD_I2C_PORTA		0          // port A
;      78 #define AD_I2C_PORTB		1          // port B
;      79 #define AD_I2C_PORTC		2	   // port C
;      80 #define AD_I2C_PORTD		3          // port D
;      81 
;      82 // Adresses des ports I2C
;      83 #define I2C_PORTA 0
;      84 #define I2C_PORTB 1
;      85 #define I2C_PORTC 2
;      86 #define I2C_PORTD 3
;      87 
;      88 // Etat du graphe
;      89 #define etage_1	  0
;      90 #define	etage_2	  1
;      91 #define etage_3   2
;      92 #define monter	  3
;      93 #define descendre 4
;      94 #define erreur    5
;      95 
;      96 // Prototype des fonctions :
;      97 void Rampe_accel(unsigned char);
;      98 void Rampe_decel(unsigned char);
;      99 void Ecrire_PCF8574(unsigned char add, unsigned char valeur);
;     100 void EL1_egal_1();
;     101 void init_CGRAM(char valeur[8][8]);
;     102 unsigned char Lire_PCF8574(unsigned char add);
;     103 
;     104 // Caractres personnaliss placs dans la mmoire CGRAM du LCD
;     105 
;     106 
;     107 // Caractre n1 : ATTENTION :
;     108 //---------------------------
;     109 const unsigned char attention[8][8] = {{0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x01}, // @0 CGRAM
;     110 {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x01},        // @1 CGRAM
;     111 {0x02, 0x02, 0x04, 0x05, 0x09, 0x09, 0x11, 0x11},        // @2 CGRAM
;     112 {0x08, 0x08, 0x04, 0x14, 0x12, 0x12, 0x11, 0x11},        // @3 CGRAM
;     113 {0x01, 0x01, 0x02, 0x02, 0x04, 0x04, 0x08, 0x0f},        // @4 CGRAM
;     114 {0x01, 0x01, 0x01, 0x00, 0x01, 0x01, 0x00, 0x1f},        // @5 CGRAM
;     115 {0x10, 0x10, 0x10, 0x00, 0x10, 0x10, 0x00, 0x1f},        // @6 CGRAM
;     116 {0x10, 0x10, 0x08, 0x08, 0x04, 0x04, 0x02, 0x1e}};       // @7 CGRAM                
;     117 
;     118 // Caractre n1 : FLECHE_BAS :
;     119 //----------------------------
;     120 
;     121 // Caractre n1 : FLECHE_HAUT :
;     122 //----------------------------
;     123 
;     124 void main(void)
;     125 {
_main:
;     126 /*--------------------------------------------------------------------------------------------------------------
;     127 type 			Dsignation				      Commentaires		       
;     128 --------------------------------------------------------------------------------------------------------------*/
;     129 unsigned char etat,OCR1AL,OCR1BL;
;     130 unsigned char PO1,PO2,PO3;
;     131 unsigned char PC1,PC2,PC3;
;     132 unsigned char AP1,AP2,AP3;
;     133 unsigned char AC1,AC2,AC3;
;     134 unsigned char VP1,VP2,VP3;
;     135 unsigned char LED1,LED2,LED3;
;     136 unsigned char DEF,coef;
;     137 unsigned char EtatPORTA,EtatPORTB,EtatPORTC,EtatPORTD; 
;     138 
;     139 // Input/Output Ports initialization
;     140 // Port A initialization
;     141 // Func0=In Func1=In Func2=In Func3=In Func4=In Func5=In Func6=In Func7=In 
;     142 // State0=T State1=T State2=T State3=T State4=T State5=T State6=T State7=T 
;     143 PORTA=0x00;
	SBIW R28,21
;	etat -> R16
;	OCR1AL -> R17
;	OCR1BL -> R18
;	PO1 -> R19
;	PO2 -> R20
;	PO3 -> R21
;	PC1 -> Y+20
;	PC2 -> Y+19
;	PC3 -> Y+18
;	AP1 -> Y+17
;	AP2 -> Y+16
;	AP3 -> Y+15
;	AC1 -> Y+14
;	AC2 -> Y+13
;	AC3 -> Y+12
;	VP1 -> Y+11
;	VP2 -> Y+10
;	VP3 -> Y+9
;	LED1 -> Y+8
;	LED2 -> Y+7
;	LED3 -> Y+6
;	DEF -> Y+5
;	coef -> Y+4
;	EtatPORTA -> Y+3
;	EtatPORTB -> Y+2
;	EtatPORTC -> Y+1
;	EtatPORTD -> Y+0
	CLR  R30
	OUT  0x1B,R30
;     144 DDRA=0x00;
	OUT  0x1A,R30
;     145 
;     146 // Port B initialization
;     147 // Func0=In Func1=In Func2=In Func3=In Func4=In Func5=In Func6=In Func7=In 
;     148 // State0=T State1=T State2=T State3=T State4=T State5=T State6=T State7=T 
;     149 PORTB=0x00;
	OUT  0x18,R30
;     150 DDRB=0x00;
	OUT  0x17,R30
;     151 
;     152 // Port C initialization
;     153 // Func0=In Func1=In Func2=In Func3=In Func4=In Func5=In Func6=In Func7=In 
;     154 // State0=T State1=T State2=T State3=T State4=T State5=T State6=T State7=T 
;     155 PORTC=0x00;
	OUT  0x15,R30
;     156 DDRC=0x00;
	OUT  0x14,R30
;     157 
;     158 // Port D initialization
;     159 // Func0=Out Func1=Out Func2=Out Func3=Out Func4=Out Func5=Out Func6=Out Func7=Out 
;     160 // State0=0 State1=0 State2=0 State3=0 State4=0 State5=0 State6=0 State7=0 
;     161 PORTD=0x00;
	OUT  0x12,R30
;     162 DDRD=0xFF;
	LDI  R30,LOW(255)
	OUT  0x11,R30
;     163 
;     164 // Timer/Counter 0 initialization
;     165 // Clock source: System Clock
;     166 // Clock value: Timer 0 Stopped
;     167 TCCR0=0x00;
	CLR  R30
	OUT  0x33,R30
;     168 TCNT0=0x00;
	OUT  0x32,R30
;     169 
;     170 // Timer/Counter 1 initialization
;     171 // Clock source: System Clock
;     172 // Clock value: 15,625 kHz
;     173 // Mode: Ph. correct PWM top=00FFh
;     174 // OC1A output: Non-Inv.
;     175 // OC1B output: Non-Inv.
;     176 // Noise Canceler: Off
;     177 // Input Capture on Falling Edge
;     178 // Timer 1 Overflow Interrupt: Off
;     179 // Input Capture Interrupt: Off
;     180 // Compare A Match Interrupt: Off
;     181 // Compare B Match Interrupt: Off
;     182 TCCR1A=0xA1;
	LDI  R30,LOW(161)
	OUT  0x2F,R30
;     183 TCCR1B=0x04;
	LDI  R30,LOW(4)
	OUT  0x2E,R30
;     184 TCNT1H=0x00;
	CLR  R30
	OUT  0x2D,R30
;     185 TCNT1L=0x00;
	OUT  0x2C,R30
;     186 OCR1AH=0x00;
	OUT  0x2B,R30
;     187 OCR1AL=0x00;
	LDI  R17,LOW(0)
;     188 OCR1BH=0x00;
	OUT  0x29,R30
;     189 OCR1BL=0x00;
	LDI  R18,LOW(0)
;     190 
;     191 // Timer/Counter 2 initialization
;     192 // Clock source: System Clock
;     193 // Clock value: Timer 2 Stopped
;     194 // Mode: Normal top=FFh
;     195 // OC2 output: Disconnected
;     196 ASSR=0x00;
	OUT  0x22,R30
;     197 TCCR2=0x00;
	OUT  0x25,R30
;     198 TCNT2=0x00;
	OUT  0x24,R30
;     199 OCR2=0x00;
	OUT  0x23,R30
;     200 
;     201 // External Interrupt(s) initialization
;     202 // INT0: On
;     203 // INT0 Mode: Rising Edge
;     204 // INT1: Off
;     205 GIMSK=0x40;
	LDI  R30,LOW(64)
	OUT  0x3B,R30
;     206 MCUCR=0x03;
	LDI  R30,LOW(3)
	OUT  0x35,R30
;     207 GIFR=0x40;
	LDI  R30,LOW(64)
	OUT  0x3A,R30
;     208 
;     209 // Timer(s)/Counter(s) Interrupt(s) initialization
;     210 TIMSK=0x00;
	CLR  R30
	OUT  0x39,R30
;     211 
;     212 // Analog Comparator initialization
;     213 // Analog Comparator: Off
;     214 // Analog Comparator Input Capture by Timer/Counter 1: Off
;     215 // Analog Comparator Output: Off
;     216 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
;     217 
;     218 // I2C Bus initialisation
;     219 i2c_init();
	RCALL _i2c_init
;     220 
;     221 // LCD module initialisation
;     222 //lcd_init(20);        
;     223 
;     224 // Global enable interrupts
;     225 #asm("sei")
	sei
;     226 
;     227 // initialisation :
;     228 //----------------
;     229 
;     230 {
;     231 sprintf(display_buffer_ligne0,"   PPE ascenseur");
	RCALL SUBOPT_0x0
	__POINTW1FN _47,0
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x1
;     232 sprintf(display_buffer_ligne1,"    2006 / 2007");
	RCALL SUBOPT_0x2
	__POINTW1FN _47,17
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x1
;     233 sprintf(display_buffer_ligne2,"     Carte SSI");
	RCALL SUBOPT_0x3
	__POINTW1FN _47,33
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x1
;     234 sprintf(display_buffer_ligne3,"  Lyce P-E MARTIN");
	RCALL SUBOPT_0x4
	__POINTW1FN _47,48
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x1
;     235 //Affiche_LCD1(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2,display_buffer_ligne3);
;     236 delay_ms(4000);
	LDI  R30,LOW(4000)
	LDI  R31,HIGH(4000)
	RCALL SUBOPT_0x5
;     237 
;     238 //faire descendre la cabine jusqu' l'tage 1 et faire clignoter les leds et afficher
;     239 //-----------------------------------------------------------------------------------
;     240 while (PC1==0)                         
_0x30:
	LDD  R30,Y+20
	CPI  R30,0
	BRNE _0x32
;     241   {
;     242   sprintf(display_buffer_ligne0,"   Initialisation");
	RCALL SUBOPT_0x0
	__POINTW1FN _47,67
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x1
;     243   sprintf(display_buffer_ligne1,"        ----");
	RCALL SUBOPT_0x2
	__POINTW1FN _47,85
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x1
;     244   sprintf(display_buffer_ligne2," dplacement de la");
	RCALL SUBOPT_0x3
	__POINTW1FN _47,98
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x1
;     245   sprintf(display_buffer_ligne3,"cabine jusqu'au RDC");
	RCALL SUBOPT_0x4
	__POINTW1FN _47,117
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x1
;     246   //Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2,display_buffer_ligne3);
;     247   //OCR1AL=;              //  complter : lancer le moteur en descente
;     248   //OCR1BL=;              //  complter : lancer le moteur en descente
;     249   LED1=1;
	RCALL SUBOPT_0x6
;     250   LED2=1;
	RCALL SUBOPT_0x7
;     251   LED3=1;
	RCALL SUBOPT_0x8
;     252   DEF=1;
	RCALL SUBOPT_0x9
;     253   delay_ms(500);
	LDI  R30,LOW(500)
	LDI  R31,HIGH(500)
	RCALL SUBOPT_0x5
;     254   LED1=0;
	RCALL SUBOPT_0xA
;     255   LED2=0;
	RCALL SUBOPT_0xB
;     256   LED3=0;
	RCALL SUBOPT_0xC
;     257   DEF=0;
	CLR  R30
	STD  Y+5,R30
;     258   }
	RJMP _0x30
_0x32:
;     259 OCR1AL=0;                // arrter le moteur
	LDI  R17,LOW(0)
;     260 OCR1BL=0;                // arrter le moteur
	LDI  R18,LOW(0)
;     261 etat=etage_1;
	LDI  R16,LOW(0)
;     262 }
;     263 
;     264 //fin initialisation
;     265 
;     266 while (1)
_0x33:
;     267       {
;     268       switch (etat)
	RCALL SUBOPT_0xD
;     269       {
;     270       case etage_1 : EL1_egal_1();
	BREQ PC+2
	RJMP _0x39
	RCALL _EL1_egal_1
;     271                      LED1=1;
	RCALL SUBOPT_0x6
;     272                      sprintf(display_buffer_ligne0,"Etage 1");
	RCALL SUBOPT_0x0
	__POINTW1FN _47,137
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x1
;     273                      sprintf(display_buffer_ligne1,"");
	RCALL SUBOPT_0x2
	__POINTW1FN _47,145
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x1
;     274                      sprintf(display_buffer_ligne2,"attente appel");
	RCALL SUBOPT_0x3
	__POINTW1FN _47,146
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x1
;     275                      sprintf(display_buffer_ligne3,"porte 1 deverouillee");
	RCALL SUBOPT_0x4
	__POINTW1FN _47,160
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x1
;     276                      //Affiche_LCD1(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2,display_buffer_ligne3);
;     277                if ((AP2 == 1)||(AC2 == 1))
	RCALL SUBOPT_0xE
	BREQ _0x3B
	RCALL SUBOPT_0xF
	BRNE _0x3A
_0x3B:
;     278        	       	 {
;     279        	  	   do           //crire ce qui suit TANT QUE porte 1 ouverte (tant que PO1=1)
_0x3E:
;     280        	  	   {
;     281        	  	   sprintf(display_buffer_ligne0,"tage 2 demand");
	RCALL SUBOPT_0x0
	__POINTW1FN _47,181
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x1
;     282        	  	   sprintf(display_buffer_ligne1,"");       
	RCALL SUBOPT_0x2
	__POINTW1FN _47,197
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x1
;     283                    sprintf(display_buffer_ligne2,"fermer la porte !!");
	RCALL SUBOPT_0x3
	__POINTW1FN _47,198
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x1
;     284                    sprintf(display_buffer_ligne3,"");
	RCALL SUBOPT_0x4
	__POINTW1FN _47,217
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x1
;     285        	           //Affiche_LCD1(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2,display_buffer_ligne3);
;     286                    coef=1; 
	RCALL SUBOPT_0x10
;     287                    }
;     288                    while(PO1==1);
	CPI  R19,1
	BREQ _0x3E
;     289                    etat=monter; 
	LDI  R16,LOW(3)
;     290                  }
;     291        	       	else if  ((AP3 == 1)||(AC3 == 1))
	RJMP _0x40
_0x3A:
	RCALL SUBOPT_0x11
	BREQ _0x42
	RCALL SUBOPT_0x12
	BRNE _0x41
_0x42:
;     292        	       	 {
;     293        	  	   do           //crire ce qui suit TANT QUE porte 1 ouverte (tant que PO1=1)
_0x45:
;     294        	  	   {
;     295        	  	   sprintf(display_buffer_ligne0,"tage 3 demand");
	RCALL SUBOPT_0x0
	__POINTW1FN _47,218
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x1
;     296        	  	   sprintf(display_buffer_ligne1,"");
	RCALL SUBOPT_0x2
	__POINTW1FN _47,234
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x1
;     297                    sprintf(display_buffer_ligne2,"fermer la porte !!");
	RCALL SUBOPT_0x3
	__POINTW1FN _47,235
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x1
;     298        	           sprintf(display_buffer_ligne3,"");
	RCALL SUBOPT_0x4
	__POINTW1FN _47,254
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x1
;     299        	           //Affiche_LCD1(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2,display_buffer_ligne3);
;     300                    coef=2;
	RCALL SUBOPT_0x13
;     301                    }
;     302        	           while(PO1==1);
	CPI  R19,1
	BREQ _0x45
;     303        	           
;     304        	           etat=monter;
	LDI  R16,LOW(3)
;     305                  }
;     306                 else etat=etage_1;
	RJMP _0x47
_0x41:
	LDI  R16,LOW(0)
_0x47:
_0x40:
;     307                 LED1=0;
	RCALL SUBOPT_0xA
;     308       break;
	RJMP _0x38
;     309       
;     310       case etage_2 :  EL2=1;
_0x39:
	CPI  R30,LOW(0x1)
	BREQ PC+2
	RJMP _0x48
	LDI  R30,LOW(1)
	MOV  R5,R30
;     311                       LED2=1;
	RCALL SUBOPT_0x7
;     312                       sprintf(display_buffer_ligne0,"Etage 2");
	RCALL SUBOPT_0x0
	__POINTW1FN _47,255
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x1
;     313                       sprintf(display_buffer_ligne1,"");
	RCALL SUBOPT_0x2
	__POINTW1FN _47,263
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x1
;     314                       sprintf(display_buffer_ligne2,"attente appel");
	RCALL SUBOPT_0x3
	__POINTW1FN _47,264
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x1
;     315                       sprintf(display_buffer_ligne3,"porte 2 deverouillee");
	RCALL SUBOPT_0x4
	__POINTW1FN _47,278
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x1
;     316                       //Affiche_LCD1(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2,display_buffer_ligne3);
;     317                 if ((AP1 == 1)||(AC1 == 1))
	RCALL SUBOPT_0x14
	BREQ _0x4A
	RCALL SUBOPT_0x15
	BRNE _0x49
_0x4A:
;     318                  {
;     319        	  	   do           //crire ce qui suit TANT QUE porte 2 ouverte (tant que PO2=1)
_0x4D:
;     320        	  	   {
;     321        	  	   sprintf(display_buffer_ligne0,"etage 1 demand");
	RCALL SUBOPT_0x0
	__POINTW1FN _47,299
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x1
;     322        	  	   sprintf(display_buffer_ligne1,"");
	RCALL SUBOPT_0x2
	__POINTW1FN _47,315
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x1
;     323                    sprintf(display_buffer_ligne2,"fermer la porte !");
	RCALL SUBOPT_0x3
	__POINTW1FN _47,316
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x1
;     324        	           sprintf(display_buffer_ligne3,"");
	RCALL SUBOPT_0x4
	__POINTW1FN _47,334
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x1
;     325        	           //Affiche_LCD1(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2,display_buffer_ligne3);
;     326                    coef=1; 
	RCALL SUBOPT_0x10
;     327                    }
;     328                    while(PO2==1); 
	CPI  R20,1
	BREQ _0x4D
;     329                    etat=descendre;
	LDI  R16,LOW(4)
;     330                  }
;     331                  
;     332        	       	else if  ((AP3 == 1)||(AC3 == 1))
	RJMP _0x4F
_0x49:
	RCALL SUBOPT_0x11
	BREQ _0x51
	RCALL SUBOPT_0x12
	BRNE _0x50
_0x51:
;     333        	       	 {
;     334        	  	   do           //crire ce qui suit TANT QUE porte 2 ouverte (tant que PO2=1)
_0x54:
;     335        	  	   {
;     336        	  	   sprintf(display_buffer_ligne0,"etage 3 demand");
	RCALL SUBOPT_0x0
	__POINTW1FN _47,335
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x1
;     337        	  	   sprintf(display_buffer_ligne1,"");
	RCALL SUBOPT_0x2
	__POINTW1FN _47,351
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x1
;     338                    sprintf(display_buffer_ligne2,"fermer la porte !");
	RCALL SUBOPT_0x3
	__POINTW1FN _47,352
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x1
;     339        	           sprintf(display_buffer_ligne3,"");
	RCALL SUBOPT_0x4
	__POINTW1FN _47,370
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x1
;     340        	           //Affiche_LCD1(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2,display_buffer_ligne3);
;     341                    coef=1;
	RCALL SUBOPT_0x10
;     342                    }   
;     343                    while(PO2==1);
	CPI  R20,1
	BREQ _0x54
;     344                    etat=monter;
	LDI  R16,LOW(3)
;     345                  }
;     346        	       	else etat=etage_2;
	RJMP _0x56
_0x50:
	LDI  R16,LOW(1)
_0x56:
_0x4F:
;     347        	       	LED2=0;
	RCALL SUBOPT_0xB
;     348       break; 
	RJMP _0x38
;     349       
;     350       case etage_3 :  EL3=1;
_0x48:
	CPI  R30,LOW(0x2)
	BREQ PC+2
	RJMP _0x57
	LDI  R30,LOW(1)
	MOV  R6,R30
;     351                       LED3=1;
	RCALL SUBOPT_0x8
;     352                       sprintf(display_buffer_ligne0,"etage 3");
	RCALL SUBOPT_0x0
	__POINTW1FN _47,371
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x1
;     353                       sprintf(display_buffer_ligne1,"");
	RCALL SUBOPT_0x2
	__POINTW1FN _47,379
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x1
;     354                       sprintf(display_buffer_ligne2,"attente appel");
	RCALL SUBOPT_0x3
	__POINTW1FN _47,380
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x1
;     355                       sprintf(display_buffer_ligne3,"porte 3 deverouillee");
	RCALL SUBOPT_0x4
	__POINTW1FN _47,394
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x1
;     356                       //Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2,display_buffer_ligne3);
;     357                 if ((AP1 == 1)||(AC1 == 1))
	RCALL SUBOPT_0x14
	BREQ _0x59
	RCALL SUBOPT_0x15
	BRNE _0x58
_0x59:
;     358                  {
;     359        	  	   do           //crire ce qui suit TANT QUE porte 3 ouverte (tant que PO3=1)
_0x5C:
;     360        	  	   {
;     361        	  	   sprintf(display_buffer_ligne0,"etage 1 demand");
	RCALL SUBOPT_0x0
	__POINTW1FN _47,415
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x1
;     362        	  	   sprintf(display_buffer_ligne1,"");
	RCALL SUBOPT_0x2
	__POINTW1FN _47,431
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x1
;     363                    sprintf(display_buffer_ligne2,"fermer la porte !");
	RCALL SUBOPT_0x3
	__POINTW1FN _47,432
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x1
;     364        	           sprintf(display_buffer_ligne3,"");
	RCALL SUBOPT_0x4
	__POINTW1FN _47,450
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x1
;     365        	           //Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2,display_buffer_ligne3);
;     366                    coef=2; 
	RCALL SUBOPT_0x13
;     367                    }
;     368                    while(PO3==1);
	CPI  R21,1
	BREQ _0x5C
;     369                    etat=descendre;
	LDI  R16,LOW(4)
;     370                  }
;     371        	       	else if  ((AP2 == 1)||(AC2 == 1))
	RJMP _0x5E
_0x58:
	RCALL SUBOPT_0xE
	BREQ _0x60
	RCALL SUBOPT_0xF
	BRNE _0x5F
_0x60:
;     372        	       	 {
;     373        	  	   do           //crire ce qui suit TANT QUE porte 3 ouverte (tant que PO3=1)
_0x63:
;     374        	  	   {
;     375        	  	   sprintf(display_buffer_ligne0,"etage 2 demand");
	RCALL SUBOPT_0x0
	__POINTW1FN _47,451
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x1
;     376        	  	   sprintf(display_buffer_ligne1,"");
	RCALL SUBOPT_0x2
	__POINTW1FN _47,467
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x1
;     377                    sprintf(display_buffer_ligne2,"fermer la porte !");
	RCALL SUBOPT_0x3
	__POINTW1FN _47,468
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x1
;     378        	           sprintf(display_buffer_ligne3,"");
	RCALL SUBOPT_0x4
	__POINTW1FN _47,486
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x1
;     379        	           //Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2,display_buffer_ligne3);
;     380                    coef=1;
	RCALL SUBOPT_0x10
;     381                    }
;     382        	           while(PO3==1);
	CPI  R21,1
	BREQ _0x63
;     383                    etat=descendre;
	LDI  R16,LOW(4)
;     384                  }
;     385                  else etat=etage_3;
	RJMP _0x65
_0x5F:
	LDI  R16,LOW(2)
_0x65:
_0x5E:
;     386                  LED3=0;
	RCALL SUBOPT_0xC
;     387       break; 
	RJMP _0x38
;     388       
;     389       case monter : OCR1AL=0  ;      			 //  complter (moteur  l'arrt)
_0x57:
	CPI  R30,LOW(0x3)
	BRNE _0x66
	LDI  R17,LOW(0)
;     390                     OCR1BL=0  ;      			 //  complter
	LDI  R18,LOW(0)
;     391                     while ((PO1==0)||(PO2==0)||(PO3==0));
_0x67:
	CPI  R19,0
	BREQ _0x6A
	CPI  R20,0
	BREQ _0x6A
	CPI  R21,0
	BRNE _0x69
_0x6A:
	RJMP _0x67
_0x69:
;     392                     if ((VP1==1)&&(VP2==1)&&(VP3==1))                            
	RCALL SUBOPT_0x16
	BRNE _0x6D
	RCALL SUBOPT_0x17
	BRNE _0x6D
	RCALL SUBOPT_0x18
	BREQ _0x6E
_0x6D:
	RJMP _0x6C
_0x6E:
;     393                       {
;     394                       Rampe_accel(0);
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x1A
;     395                       delay_ms(coef*500);
;     396                       Rampe_decel(0);
	RCALL SUBOPT_0x19
	RCALL _Rampe_decel
;     397                       }
;     398                      else
	RJMP _0x6F
_0x6C:
;     399                       etat=erreur;
	LDI  R16,LOW(5)
_0x6F:
;     400                     while ((PC2==0)||(PC3==0));
_0x70:
	RCALL SUBOPT_0x1B
	BREQ _0x73
	LDD  R26,Y+18
	CPI  R26,LOW(0x0)
	BRNE _0x72
_0x73:
	RJMP _0x70
_0x72:
;     401                       OCR1AL=0  ;      			 //  complter (moteur  l'arrt)
	LDI  R17,LOW(0)
;     402                       OCR1BL=0  ;      			 //  complter
	LDI  R18,LOW(0)
;     403                     if (PC2==1)                        
	RCALL SUBOPT_0x1C
	BRNE _0x75
;     404                      etat=etage_2;
	LDI  R16,LOW(1)
;     405                      else if (PC3==1)                        
	RJMP _0x76
_0x75:
	LDD  R26,Y+18
	CPI  R26,LOW(0x1)
	BRNE _0x77
;     406                       etat=etage_3;
	LDI  R16,LOW(2)
;     407                       else etat=erreur;
	RJMP _0x78
_0x77:
	LDI  R16,LOW(5)
_0x78:
_0x76:
;     408       break; 
	RJMP _0x38
;     409       	
;     410       case descendre : OCR1AL=0  ;     			 //  complter (moteur  l'arrt)
_0x66:
	CPI  R30,LOW(0x4)
	BRNE _0x79
	LDI  R17,LOW(0)
;     411                        OCR1BL=0  ;     			 //  complter
	LDI  R18,LOW(0)
;     412                        while ((PO1==0)||(PO2==0)||(PO3==0));                        
_0x7A:
	CPI  R19,0
	BREQ _0x7D
	CPI  R20,0
	BREQ _0x7D
	CPI  R21,0
	BRNE _0x7C
_0x7D:
	RJMP _0x7A
_0x7C:
;     413                        if ((VP1==1)&&(VP2==1)&&(VP3==1))                            
	RCALL SUBOPT_0x16
	BRNE _0x80
	RCALL SUBOPT_0x17
	BRNE _0x80
	RCALL SUBOPT_0x18
	BREQ _0x81
_0x80:
	RJMP _0x7F
_0x81:
;     414                          {
;     415                          Rampe_accel(1);
	RCALL SUBOPT_0x1D
	RCALL SUBOPT_0x1A
;     416                          delay_ms(coef*500);
;     417                          Rampe_decel(1);
	RCALL SUBOPT_0x1D
	RCALL _Rampe_decel
;     418                          }
;     419                         else etat=erreur;
	RJMP _0x82
_0x7F:
	LDI  R16,LOW(5)
_0x82:
;     420                        while ((PC2==0)||(PC1==0));
_0x83:
	RCALL SUBOPT_0x1B
	BREQ _0x86
	LDD  R26,Y+20
	CPI  R26,LOW(0x0)
	BRNE _0x85
_0x86:
	RJMP _0x83
_0x85:
;     421                         OCR1AL=0  ;      		 //  complter (arrter le moteur)
	LDI  R17,LOW(0)
;     422                         OCR1BL=0  ;      		 //  complter  
	LDI  R18,LOW(0)
;     423                        if (PC2==1)
	RCALL SUBOPT_0x1C
	BRNE _0x88
;     424                         etat=etage_2;
	LDI  R16,LOW(1)
;     425                         else if (PC1==1)
	RJMP _0x89
_0x88:
	LDD  R26,Y+20
	CPI  R26,LOW(0x1)
	BRNE _0x8A
;     426                        	 etat=etage_1;
	LDI  R16,LOW(0)
;     427                          else etat=erreur;
	RJMP _0x8B
_0x8A:
	LDI  R16,LOW(5)
_0x8B:
_0x89:
;     428       break;
	RJMP _0x38
;     429       
;     430       case erreur : DEF=1;
_0x79:
	CPI  R30,LOW(0x5)
	BRNE _0x38
	RCALL SUBOPT_0x9
;     431                     init_CGRAM(attention);
	LDI  R30,LOW(_attention*2)
	LDI  R31,HIGH(_attention*2)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _init_CGRAM
;     432                     lcd_gotoxy(17,0);		// caractre perso (ATTENTION) ligne 0
	RCALL SUBOPT_0x1E
	RCALL SUBOPT_0x19
	RCALL _lcd_gotoxy
;     433 		    lcd_putchar(0);
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x1F
;     434 		    lcd_gotoxy(18,0);
	RCALL SUBOPT_0x19
	RCALL _lcd_gotoxy
;     435 		    lcd_putchar(1);
	RCALL SUBOPT_0x1D
	RCALL SUBOPT_0x20
;     436 		    lcd_gotoxy(17,1);           // caractre perso (ATTENTION) ligne 1
	RCALL SUBOPT_0x1D
	RCALL _lcd_gotoxy
;     437 		    lcd_putchar(2);
	RCALL SUBOPT_0x21
	RCALL SUBOPT_0x1F
;     438 		    lcd_gotoxy(18,1);
	RCALL SUBOPT_0x1D
	RCALL _lcd_gotoxy
;     439 		    lcd_putchar(3);
	RCALL SUBOPT_0x22
	RCALL _lcd_putchar
;     440 		    lcd_gotoxy(16,2);           // caractre perso (ATTENTION) ligne 2
	LDI  R30,LOW(16)
	RCALL SUBOPT_0x23
	RCALL _lcd_gotoxy
;     441 		    lcd_putchar(4);
	LDI  R30,LOW(4)
	ST   -Y,R30
	RCALL SUBOPT_0x20
;     442 		    lcd_gotoxy(17,2);
	RCALL SUBOPT_0x21
	RCALL _lcd_gotoxy
;     443 		    lcd_putchar(5);
	LDI  R30,LOW(5)
	ST   -Y,R30
	RCALL SUBOPT_0x1F
;     444 		    lcd_gotoxy(18,2);
	RCALL SUBOPT_0x21
	RCALL _lcd_gotoxy
;     445 		    lcd_putchar(6);
	LDI  R30,LOW(6)
	RCALL SUBOPT_0x24
;     446 		    lcd_gotoxy(19,2);
	LDI  R30,LOW(19)
	RCALL SUBOPT_0x23
	RCALL _lcd_gotoxy
;     447 		    lcd_putchar(7);
	LDI  R30,LOW(7)
	RCALL SUBOPT_0x24
;     448       break;
;     449    }
_0x38:
;     450   };
	RJMP _0x33
;     451 
;     452 AP1 = (Lire_PCF8574(I2C_PORTA)&0b01000000);        // lecture PA6
	RCALL SUBOPT_0x19
	RCALL _Lire_PCF8574
	ANDI R30,LOW(0x40)
	STD  Y+17,R30
;     453 AP2 = (Lire_PCF8574(I2C_PORTA)&0b10000000);        // lecture PA7
	RCALL SUBOPT_0x19
	RCALL _Lire_PCF8574
	ANDI R30,LOW(0x80)
	STD  Y+16,R30
;     454 AP3 = (Lire_PCF8574(I2C_PORTB)&0b00000001);        // lecture PB0
	RCALL SUBOPT_0x1D
	RCALL SUBOPT_0x25
	STD  Y+15,R30
;     455 AC1 = (Lire_PCF8574(I2C_PORTB)&0b00000010);        // lecture PB1
	RCALL SUBOPT_0x1D
	RCALL SUBOPT_0x26
	STD  Y+14,R30
;     456 AC2 = (Lire_PCF8574(I2C_PORTB)&0b00000100);        // lecture PB2
	RCALL SUBOPT_0x1D
	RCALL SUBOPT_0x27
	STD  Y+13,R30
;     457 AC3 = (Lire_PCF8574(I2C_PORTB)&0b00001000);        // lecture PB3
	RCALL SUBOPT_0x1D
	RCALL SUBOPT_0x28
	STD  Y+12,R30
;     458 PO1 = (Lire_PCF8574(I2C_PORTA)&0b00001000);        // lecture PA3
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x28
	MOV  R19,R30
;     459 PO2 = (Lire_PCF8574(I2C_PORTA)&0b00010000);        // lecture PA4
	RCALL SUBOPT_0x19
	RCALL _Lire_PCF8574
	ANDI R30,LOW(0x10)
	MOV  R20,R30
;     460 PO3 = (Lire_PCF8574(I2C_PORTA)&0b00100000);        // lecture PA5
	RCALL SUBOPT_0x19
	RCALL _Lire_PCF8574
	ANDI R30,LOW(0x20)
	MOV  R21,R30
;     461 VP1 = (Lire_PCF8574(I2C_PORTC)&0b00000001);        // lecture PC0
	RCALL SUBOPT_0x21
	RCALL SUBOPT_0x25
	STD  Y+11,R30
;     462 VP2 = (Lire_PCF8574(I2C_PORTC)&0b00000010);        // lecture PC1
	RCALL SUBOPT_0x21
	RCALL SUBOPT_0x26
	STD  Y+10,R30
;     463 VP3 = (Lire_PCF8574(I2C_PORTC)&0b00000100);        // lecture PC2
	RCALL SUBOPT_0x21
	RCALL SUBOPT_0x27
	STD  Y+9,R30
;     464 PC1 = (Lire_PCF8574(I2C_PORTA)&0b00000001);        // lecture PA0
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x25
	STD  Y+20,R30
;     465 PC2 = (Lire_PCF8574(I2C_PORTA)&0b00000010);        // lecture PA1
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x26
	STD  Y+19,R30
;     466 PC3 = (Lire_PCF8574(I2C_PORTA)&0b00000100);        // lecture PA2
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x27
	STD  Y+18,R30
;     467 
;     468 EtatPORTA = (Lire_PCF8574(I2C_PORTA));           // lecture du port A
	RCALL SUBOPT_0x19
	RCALL _Lire_PCF8574
	STD  Y+3,R30
;     469 EtatPORTB = (Lire_PCF8574(I2C_PORTB));           // Lecture du port B
	RCALL SUBOPT_0x1D
	RCALL _Lire_PCF8574
	STD  Y+2,R30
;     470 EtatPORTC = (Lire_PCF8574(I2C_PORTC));           // Lecture du port C
	RCALL SUBOPT_0x21
	RCALL _Lire_PCF8574
	STD  Y+1,R30
;     471 EtatPORTD = (Lire_PCF8574(I2C_PORTD));           // Lecture du port D
	RCALL SUBOPT_0x22
	RCALL _Lire_PCF8574
	RCALL SUBOPT_0x29
;     472                                         
;     473 EtatPORTD=EtatPORTD | 0b00010000;	// LED1 = 1
	ORI  R30,0x10
	RCALL SUBOPT_0x29
;     474 EtatPORTD=EtatPORTD & 0b11101111;	// LED1 = 0		
	ANDI R30,0xEF
	RCALL SUBOPT_0x29
;     475 
;     476 EtatPORTD=EtatPORTD | 0b00100000;	// LED2 = 1
	ORI  R30,0x20
	RCALL SUBOPT_0x29
;     477 EtatPORTD=EtatPORTD & 0b11011111;	// LED2 = 0
	ANDI R30,0xDF
	RCALL SUBOPT_0x29
;     478                                        
;     479 EtatPORTD=EtatPORTD | 0b01000000;	// LED3 = 1
	ORI  R30,0x40
	RCALL SUBOPT_0x29
;     480 EtatPORTD=EtatPORTD & 0b10111111;	// LED3 = 0
	ANDI R30,0xBF
	RCALL SUBOPT_0x29
;     481 
;     482 EtatPORTD=EtatPORTD | 0b00000010;	// EL1 = 1
	ORI  R30,2
	RCALL SUBOPT_0x29
;     483 EtatPORTD=EtatPORTD & 0b11111101;	// EL1 = 0
	ANDI R30,0xFD
	RCALL SUBOPT_0x29
;     484 
;     485 EtatPORTD=EtatPORTD | 0b00000100;	// EL2 = 1
	ORI  R30,4
	RCALL SUBOPT_0x29
;     486 EtatPORTD=EtatPORTD & 0b11111011;	// EL2 = 0
	ANDI R30,0xFB
	RCALL SUBOPT_0x29
;     487 
;     488 EtatPORTD=EtatPORTD | 0b00001000;	// EL3 = 1
	ORI  R30,8
	RCALL SUBOPT_0x29
;     489 EtatPORTD=EtatPORTD & 0b11110111;	// EL3 = 0
	ANDI R30,0XF7
	RCALL SUBOPT_0x29
;     490 
;     491 EtatPORTD=EtatPORTD | 0b00000001;	// DEF = 1
	ORI  R30,1
	RCALL SUBOPT_0x29
;     492 EtatPORTD=EtatPORTD & 0b11111110;	// DEF = 0
	ANDI R30,0xFE
	ST   Y,R30
;     493 
;     494 Ecrire_PCF8574(I2C_PORTD,EtatPORTD);
	RCALL SUBOPT_0x22
	RCALL SUBOPT_0x2A
	RCALL _Ecrire_PCF8574
;     495 }
	ADIW R28,21
_0x8D:
	RJMP _0x8D
;     496 
;     497 //fin du programme principal
;     498 
;     499 
;     500 
;     501 // Sous-programmes
;     502 //----------------
;     503 
;     504 void Rampe_accel(unsigned char mouvement)           // Sous-programme rampe acceleration
;     505     {
_Rampe_accel:
;     506      unsigned char I=0;
;     507      do
	ST   -Y,R16
;	mouvement -> Y+1
;	I -> R16
	LDI  R16,0
_0x90:
;     508       {
;     509       I=I+10;
	SUBI R16,-LOW(10)
;     510       delay_ms(100);
	RCALL SUBOPT_0x2B
;     511       if (mouvement==0)
	RCALL SUBOPT_0x2C
	BRNE _0x92
;     512        {
;     513        OCR1AL=I;
	OUT  0x2A,R16
;     514        OCR1BL=0;
	RCALL SUBOPT_0x2D
;     515        }
;     516        else
	RJMP _0x93
_0x92:
;     517        	{
;     518        	OCR1AL=0;
	RCALL SUBOPT_0x2E
;     519        	OCR1BL=I;
	OUT  0x28,R16
;     520        	}
_0x93:
;     521       }
;     522      while (I<255);
	CPI  R16,255
	BRLO _0x90
;     523     }
	LDD  R16,Y+0
	RJMP _0x13E
;     524 
;     525 void Rampe_decel(unsigned char mouvement)           // Sous-programme rampe deceleration
;     526     {
_Rampe_decel:
;     527      unsigned char J=255;
;     528      do
	ST   -Y,R16
;	mouvement -> Y+1
;	J -> R16
	LDI  R16,255
_0x96:
;     529       {
;     530       J=J-10;
	SUBI R16,LOW(10)
;     531       delay_ms(100);
	RCALL SUBOPT_0x2B
;     532       if (mouvement==0)
	RCALL SUBOPT_0x2C
	BRNE _0x98
;     533        {
;     534        OCR1AL=J;
	OUT  0x2A,R16
;     535        OCR1BL=0;
	RCALL SUBOPT_0x2D
;     536        }
;     537        else
	RJMP _0x99
_0x98:
;     538         {
;     539         OCR1AL=0;
	RCALL SUBOPT_0x2E
;     540         OCR1BL=J;
	OUT  0x28,R16
;     541         }
_0x99:
;     542       }
;     543      while (J>=50);
	CPI  R16,50
	BRSH _0x96
;     544     }
	LDD  R16,Y+0
	RJMP _0x13E
;     545     
;     546 unsigned char Lire_PCF8574(unsigned char add)          // Procdure de lecture du port I2C
;     547 {
_Lire_PCF8574:
;     548   unsigned char entrees;
;     549   i2c_start();
	ST   -Y,R16
;	add -> Y+1
;	entrees -> R16
	RCALL SUBOPT_0x2F
;     550   i2c_write(0x41 | add << 1);
	ORI  R30,LOW(0x41)
	RCALL SUBOPT_0x30
;     551   entrees = i2c_read(0);
	RCALL SUBOPT_0x19
	RCALL _i2c_read
	MOV  R16,R30
;     552   i2c_stop();
	RCALL _i2c_stop
;     553   return entrees;    
	MOV  R30,R16
	LDD  R16,Y+0
	RJMP _0x13E
;     554 } 
;     555 
;     556 
;     557 void Ecrire_PCF8574(unsigned char add, unsigned char valeur)           // Procdure d'criture sur le port I2C
;     558 {
_Ecrire_PCF8574:
;     559   i2c_start();
	RCALL SUBOPT_0x2F
;     560   i2c_write(0x40 | add << 1);
	ORI  R30,0x40
	RCALL SUBOPT_0x30
;     561   i2c_write(valeur);
	LD   R30,Y
	RCALL SUBOPT_0x30
;     562   i2c_stop();
	RCALL _i2c_stop
;     563   delay_ms(10);
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL SUBOPT_0x5
;     564 } 
_0x13E:
	ADIW R28,2
	RET
;     565 
;     566 
;     567 void EL1_egal_1()
;     568 {
_EL1_egal_1:
;     569 unsigned char EtatPORTD;
;     570 EtatPORTD=EtatPORTD | 0b00000010;	//EL1=1 
	ST   -Y,R16
;	EtatPORTD -> R16
	ORI  R16,LOW(2)
;     571 Ecrire_PCF8574(PORTD,EtatPORTD); 	//EL1=1;
	IN   R30,0x12
	ST   -Y,R30
	ST   -Y,R16
	RCALL _Ecrire_PCF8574
;     572 }         
	LD   R16,Y+
	RET
;     573  
;     574 
;     575 void init_CGRAM(char valeur[8][8])
;     576  {
_init_CGRAM:
;     577  unsigned char i,j;
;     578  for (i=0;i<8;i++)
	RCALL __SAVELOCR2
;	valeur -> Y+2
;	i -> R16
;	j -> R17
	LDI  R16,LOW(0)
_0x9F:
	CPI  R16,8
	BRSH _0xA0
;     579   {
;     580    for (j=0;j<8;j++)
	LDI  R17,LOW(0)
_0xA2:
	CPI  R17,8
	BRSH _0xA3
;     581    	lcd_write_byte(Add_Caract0_CGRAM + i, valeur[i][j]);
	MOV  R30,R16
	SUBI R30,-LOW(64)
	ST   -Y,R30
	MOV  R30,R16
	LDD  R26,Y+3
	LDD  R27,Y+3+1
	CLR  R31
	PUSH R27
	PUSH R26
	RCALL __LSLW3
	POP  R26
	POP  R27
	ADD  R26,R30
	ADC  R27,R31
	MOV  R30,R17
	CLR  R31
	ADD  R26,R30
	ADC  R27,R31
	RCALL SUBOPT_0x31
	RCALL _lcd_write_byte
	SUBI R17,-1
	RJMP _0xA2
_0xA3:
;     582     }
	SUBI R16,-1
	RJMP _0x9F
_0xA0:
;     583  }
	RCALL __LOADLOCR2
	ADIW R28,4
	RET
_getchar:
     sbis usr,rxc
     rjmp _getchar
     in   r30,udr
	RET
_putchar:
     sbis usr,udre
     rjmp _putchar
     ld   r30,y
     out  udr,r30
	ADIW R28,1
	RET
__put_G3:
	put:
	RCALL SUBOPT_0x32
	SBIW R30,0
	BREQ _0xDA
	RCALL SUBOPT_0x32
	ADIW R30,1
	RCALL __PUTWP1
	SBIW R30,1
	MOV  R26,R30
	MOV  R27,R31
	LDD  R30,Y+2
	ST   X,R30
	RJMP _0xDB
_0xDA:
	LDD  R30,Y+2
	ST   -Y,R30
	RCALL _putchar
_0xDB:
	ADIW R28,3
	RET
__print_G3:
	SBIW R28,6
	RCALL __SAVELOCR6
	LDI  R16,0
_0xDD:
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	ADIW R30,1
	STD  Y+16,R30
	STD  Y+16+1,R31
	SBIW R30,1
	LPM
	MOV  R30,R0
	MOV  R19,R30
	CPI  R30,0
	BRNE PC+2
	RJMP _0xDF
	RCALL SUBOPT_0xD
	BRNE _0xE3
	CPI  R19,37
	BRNE _0xE4
	LDI  R16,LOW(1)
	RJMP _0xE5
_0xE4:
	RCALL SUBOPT_0x33
_0xE5:
	RJMP _0xE2
_0xE3:
	CPI  R30,LOW(0x1)
	BRNE _0xE6
	CPI  R19,37
	BRNE _0xE7
	RCALL SUBOPT_0x33
	LDI  R16,LOW(0)
	RJMP _0xE2
_0xE7:
	LDI  R16,LOW(2)
	LDI  R21,LOW(0)
	LDI  R17,LOW(0)
	CPI  R19,45
	BRNE _0xE8
	LDI  R17,LOW(1)
	RJMP _0xE2
_0xE8:
	CPI  R19,43
	BRNE _0xE9
	LDI  R21,LOW(43)
	RJMP _0xE2
_0xE9:
	CPI  R19,32
	BRNE _0xEA
	LDI  R21,LOW(32)
	RJMP _0xE2
_0xEA:
	RJMP _0xEB
_0xE6:
	CPI  R30,LOW(0x2)
	BRNE _0xEC
_0xEB:
	LDI  R20,LOW(0)
	LDI  R16,LOW(3)
	CPI  R19,48
	BRNE _0xED
	ORI  R17,LOW(128)
	RJMP _0xE2
_0xED:
	RJMP _0xEE
_0xEC:
	CPI  R30,LOW(0x3)
	BREQ PC+2
	RJMP _0xE2
_0xEE:
	CPI  R19,48
	BRLO _0xF1
	CPI  R19,58
	BRLO _0xF2
_0xF1:
	RJMP _0xF0
_0xF2:
	MOV  R18,R20
	LSL  R20
	LSL  R20
	ADD  R20,R18
	LSL  R20
	MOV  R30,R19
	SUBI R30,LOW(48)
	ADD  R20,R30
	RJMP _0xE2
_0xF0:
	MOV  R30,R19
	CPI  R30,LOW(0x63)
	BRNE _0xF6
	RCALL SUBOPT_0x34
	RCALL SUBOPT_0x31
	RCALL SUBOPT_0x35
	RJMP _0xF7
_0xF6:
	CPI  R30,LOW(0x73)
	BRNE _0xF9
	RCALL SUBOPT_0x34
	RCALL SUBOPT_0x36
	RCALL _strlen
	MOV  R16,R30
	RJMP _0xFA
_0xF9:
	CPI  R30,LOW(0x70)
	BRNE _0xFC
	RCALL SUBOPT_0x34
	RCALL SUBOPT_0x36
	RCALL _strlenf
	MOV  R16,R30
	ORI  R17,LOW(8)
_0xFA:
	ORI  R17,LOW(2)
	ANDI R17,LOW(127)
	LDI  R18,LOW(0)
	RJMP _0xFD
_0xFC:
	CPI  R30,LOW(0x64)
	BREQ _0x100
	CPI  R30,LOW(0x69)
	BRNE _0x101
_0x100:
	ORI  R17,LOW(4)
	RJMP _0x102
_0x101:
	CPI  R30,LOW(0x75)
	BRNE _0x103
_0x102:
	LDI  R30,LOW(_tbl10_G3*2)
	LDI  R31,HIGH(_tbl10_G3*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R16,LOW(5)
	RJMP _0x104
_0x103:
	CPI  R30,LOW(0x58)
	BRNE _0x106
	ORI  R17,LOW(8)
	RJMP _0x107
_0x106:
	CPI  R30,LOW(0x78)
	BREQ PC+2
	RJMP _0x135
_0x107:
	LDI  R30,LOW(_tbl16_G3*2)
	LDI  R31,HIGH(_tbl16_G3*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R16,LOW(4)
_0x104:
	SBRS R17,2
	RJMP _0x109
	RCALL SUBOPT_0x34
	RCALL SUBOPT_0x37
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	SBIW R26,0
	BRGE _0x10A
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	RCALL __ANEGW1
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDI  R21,LOW(45)
_0x10A:
	CPI  R21,0
	BREQ _0x10B
	SUBI R16,-LOW(1)
	RJMP _0x10C
_0x10B:
	ANDI R17,LOW(251)
_0x10C:
	RJMP _0x10D
_0x109:
	RCALL SUBOPT_0x34
	RCALL SUBOPT_0x37
_0x10D:
_0xFD:
	SBRC R17,0
	RJMP _0x10E
_0x10F:
	CP   R16,R20
	BRSH _0x111
	SBRS R17,7
	RJMP _0x112
	SBRS R17,2
	RJMP _0x113
	ANDI R17,LOW(251)
	MOV  R19,R21
	SUBI R16,LOW(1)
	RJMP _0x114
_0x113:
	LDI  R19,LOW(48)
_0x114:
	RJMP _0x115
_0x112:
	LDI  R19,LOW(32)
_0x115:
	RCALL SUBOPT_0x33
	SUBI R20,LOW(1)
	RJMP _0x10F
_0x111:
_0x10E:
	MOV  R18,R16
	SBRS R17,1
	RJMP _0x116
_0x117:
	CPI  R18,0
	BREQ _0x119
	SBRS R17,3
	RJMP _0x11A
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,1
	STD  Y+6,R30
	STD  Y+6+1,R31
	SBIW R30,1
	LPM
	MOV  R30,R0
	RJMP _0x13F
_0x11A:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R30,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0x13F:
	ST   -Y,R30
	RCALL SUBOPT_0x35
	CPI  R20,0
	BREQ _0x11C
	SUBI R20,LOW(1)
_0x11C:
	SUBI R18,LOW(1)
	RJMP _0x117
_0x119:
	RJMP _0x11D
_0x116:
_0x11F:
	LDI  R19,LOW(48)
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,2
	STD  Y+6,R30
	STD  Y+6+1,R31
	SBIW R30,2
	RCALL __GETW1PF
	STD  Y+8,R30
	STD  Y+8+1,R31
                                      ldd  r26,y+10  ;R26,R27=n
                                      ldd  r27,y+11
                                  calc_digit:
                                      cp   r26,r30
                                      cpc  r27,r31
                                      brlo calc_digit_done
	SUBI R19,-LOW(1)
	                                  sub  r26,r30
	                                  sbc  r27,r31
	                                  brne calc_digit
                                  calc_digit_done:
                                      std  Y+10,r26 ;n=R26,R27
                                      std  y+11,r27
	LDI  R30,LOW(57)
	CP   R30,R19
	BRSH _0x121
	SBRS R17,3
	RJMP _0x122
	SUBI R19,-LOW(7)
	RJMP _0x123
_0x122:
	SUBI R19,-LOW(39)
_0x123:
_0x121:
	SBRC R17,4
	RJMP _0x125
	LDI  R30,LOW(48)
	CP   R30,R19
	BRLO _0x127
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	CPI  R26,LOW(0x1)
	LDI  R30,HIGH(0x1)
	CPC  R27,R30
	BRNE _0x126
_0x127:
	ORI  R17,LOW(16)
	RJMP _0x129
_0x126:
	CP   R20,R18
	BRLO _0x12B
	SBRS R17,0
	RJMP _0x12C
_0x12B:
	RJMP _0x12A
_0x12C:
	LDI  R19,LOW(32)
	SBRS R17,7
	RJMP _0x12D
	LDI  R19,LOW(48)
	ORI  R17,LOW(16)
_0x129:
	SBRS R17,2
	RJMP _0x12E
	ANDI R17,LOW(251)
	ST   -Y,R21
	RCALL SUBOPT_0x35
	CPI  R20,0
	BREQ _0x12F
	SUBI R20,LOW(1)
_0x12F:
_0x12E:
_0x12D:
_0x125:
	RCALL SUBOPT_0x33
	CPI  R20,0
	BREQ _0x130
	SUBI R20,LOW(1)
_0x130:
_0x12A:
	SUBI R18,LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	CP   R30,R26
	CPC  R31,R27
	BRSH _0x120
	RJMP _0x11F
_0x120:
_0x11D:
	SBRS R17,0
	RJMP _0x131
_0x132:
	CPI  R20,0
	BREQ _0x134
	SUBI R20,LOW(1)
	LDI  R30,LOW(32)
	ST   -Y,R30
	RCALL SUBOPT_0x35
	RJMP _0x132
_0x134:
_0x131:
_0x135:
_0xF7:
	LDI  R16,LOW(0)
_0xE2:
	RJMP _0xDD
_0xDF:
	RCALL __LOADLOCR6
	ADIW R28,18
	RET
_sprintf:
	MOV  R15,R24
	SBIW R28,4
	MOV  R26,R28
	MOV  R27,R29
	RCALL __ADDW2R15
	STD  Y+2,R26
	STD  Y+2+1,R27
	MOV  R26,R28
	MOV  R27,R29
	ADIW R26,6
	RCALL SUBOPT_0x38
	ST   Y,R30
	STD  Y+1,R31
	MOV  R26,R28
	MOV  R27,R29
	ADIW R26,4
	RCALL SUBOPT_0x38
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R28
	MOV  R31,R29
	ADIW R30,4
	ST   -Y,R31
	ST   -Y,R30
	RCALL __print_G3
	LD   R26,Y
	LDD  R27,Y+1
	CLR  R30
	ST   X,R30
	ADIW R28,4
	RET
    .equ __lcd_direction=__lcd_port-1
    .equ __lcd_pin=__lcd_port-2
    .equ __lcd_rs=0
    .equ __lcd_rd=1
    .equ __lcd_enable=2
    .equ __lcd_busy_flag=7

	.DSEG
__base_y_G4:
	.BYTE 0x4

	.CSEG
__lcd_ready:
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
    cbi   __lcd_port,__lcd_rs     ;RS=0
__lcd_busy:
    rcall __lcd_delay
    sbi   __lcd_port,__lcd_enable ;EN=1
    rcall __lcd_delay
    in    r26,__lcd_pin
    cbi   __lcd_port,__lcd_enable ;EN=0
    rcall __lcd_delay
    sbi   __lcd_port,__lcd_enable ;EN=1
    rcall __lcd_delay
    cbi   __lcd_port,__lcd_enable ;EN=0
    sbrc  r26,__lcd_busy_flag
    rjmp  __lcd_busy
	RET
__lcd_write_nibble:
    andi  r26,0xf0
    or    r26,r27
    out   __lcd_port,r26          ;write
    sbi   __lcd_port,__lcd_enable ;EN=1
    rcall __lcd_delay
    cbi   __lcd_port,__lcd_enable ;EN=0
__lcd_delay:
    ldi   r31,15
__lcd_delay0:
    dec   r31
    brne  __lcd_delay0
    ret
__lcd_write_data:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf7                ;set as output
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
    rcall __lcd_write_nibble      ;RD=0, write MSN
    ld    r26,y
    swap  r26
    rcall __lcd_write_nibble      ;write LSN
    sbi   __lcd_port,__lcd_rd     ;RD=1
	ADIW R28,1
	RET
_lcd_write_byte:
	RCALL __lcd_ready
	RCALL SUBOPT_0x2A
	RCALL __lcd_write_data
	RCALL __lcd_ready
    sbi   __lcd_port,__lcd_rs     ;RS=1
	LD   R30,Y
	RCALL SUBOPT_0x39
	RJMP _0x13D
_lcd_gotoxy:
	RCALL __lcd_ready
	LD   R30,Y
	CLR  R31
	SUBI R30,LOW(-__base_y_G4)
	SBCI R31,HIGH(-__base_y_G4)
	LD   R30,Z
	LDD  R26,Y+1
	ADD  R30,R26
	RCALL SUBOPT_0x39
	LDD  R7,Y+1
	LDD  R8,Y+0
_0x13D:
	ADIW R28,2
	RET
_lcd_putchar:
    push r30
    push r31
    ld   r26,y
    set
    cpi  r26,10
    breq __lcd_putchar1
    clt
	INC  R7
	CP   R9,R7
	BRSH _0x13C
	__lcd_putchar1:
	INC  R8
	RCALL SUBOPT_0x19
	ST   -Y,R8
	RCALL _lcd_gotoxy
	brts __lcd_putchar0
_0x13C:
    rcall __lcd_ready
    sbi  __lcd_port,__lcd_rs ;RS=1
    ld   r26,y
    st   -y,r26
    rcall __lcd_write_data
__lcd_putchar0:
    pop  r31
    pop  r30
	ADIW R28,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES
SUBOPT_0x0:
	LDI  R30,LOW(_display_buffer_ligne0)
	LDI  R31,HIGH(_display_buffer_ligne0)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 44 TIMES
SUBOPT_0x1:
	RCALL _sprintf
	ADIW R28,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES
SUBOPT_0x2:
	LDI  R30,LOW(_display_buffer_ligne1)
	LDI  R31,HIGH(_display_buffer_ligne1)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES
SUBOPT_0x3:
	LDI  R30,LOW(_display_buffer_ligne2)
	LDI  R31,HIGH(_display_buffer_ligne2)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES
SUBOPT_0x4:
	LDI  R30,LOW(_display_buffer_ligne3)
	LDI  R31,HIGH(_display_buffer_ligne3)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES
SUBOPT_0x5:
	ST   -Y,R31
	ST   -Y,R30
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x6:
	LDI  R30,LOW(1)
	STD  Y+8,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x7:
	LDI  R30,LOW(1)
	STD  Y+7,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x8:
	LDI  R30,LOW(1)
	STD  Y+6,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x9:
	LDI  R30,LOW(1)
	STD  Y+5,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xA:
	CLR  R30
	STD  Y+8,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xB:
	CLR  R30
	STD  Y+7,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xC:
	CLR  R30
	STD  Y+6,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xD:
	MOV  R30,R16
	CPI  R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xE:
	LDD  R26,Y+16
	CPI  R26,LOW(0x1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xF:
	LDD  R26,Y+13
	CPI  R26,LOW(0x1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x10:
	LDI  R30,LOW(1)
	STD  Y+4,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x11:
	LDD  R26,Y+15
	CPI  R26,LOW(0x1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x12:
	LDD  R26,Y+12
	CPI  R26,LOW(0x1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x13:
	LDI  R30,LOW(2)
	STD  Y+4,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x14:
	LDD  R26,Y+17
	CPI  R26,LOW(0x1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x15:
	LDD  R26,Y+14
	CPI  R26,LOW(0x1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x16:
	LDD  R26,Y+11
	CPI  R26,LOW(0x1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x17:
	LDD  R26,Y+10
	CPI  R26,LOW(0x1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x18:
	LDD  R26,Y+9
	CPI  R26,LOW(0x1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 16 TIMES
SUBOPT_0x19:
	CLR  R30
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1A:
	RCALL _Rampe_accel
	LDD  R26,Y+4
	CLR  R27
	LDI  R30,LOW(500)
	LDI  R31,HIGH(500)
	RCALL __MULW12U
	RJMP SUBOPT_0x5

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1B:
	LDD  R26,Y+19
	CPI  R26,LOW(0x0)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1C:
	LDD  R26,Y+19
	CPI  R26,LOW(0x1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES
SUBOPT_0x1D:
	LDI  R30,LOW(1)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x1E:
	LDI  R30,LOW(17)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x1F:
	RCALL _lcd_putchar
	LDI  R30,LOW(18)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x20:
	RCALL _lcd_putchar
	RJMP SUBOPT_0x1E

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES
SUBOPT_0x21:
	LDI  R30,LOW(2)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x22:
	LDI  R30,LOW(3)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x23:
	ST   -Y,R30
	RJMP SUBOPT_0x21

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x24:
	ST   -Y,R30
	RJMP _lcd_putchar

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x25:
	RCALL _Lire_PCF8574
	ANDI R30,LOW(0x1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x26:
	RCALL _Lire_PCF8574
	ANDI R30,LOW(0x2)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x27:
	RCALL _Lire_PCF8574
	ANDI R30,LOW(0x4)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x28:
	RCALL _Lire_PCF8574
	ANDI R30,LOW(0x8)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 14 TIMES
SUBOPT_0x29:
	ST   Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2A:
	LDD  R30,Y+1
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2B:
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RJMP SUBOPT_0x5

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2C:
	LDD  R30,Y+1
	CPI  R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2D:
	CLR  R30
	OUT  0x28,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2E:
	CLR  R30
	OUT  0x2A,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2F:
	RCALL _i2c_start
	LDD  R30,Y+1
	LSL  R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x30:
	ST   -Y,R30
	RJMP _i2c_write

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x31:
	LD   R30,X
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x32:
	LD   R26,Y
	LDD  R27,Y+1
	RCALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x33:
	ST   -Y,R19
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	RJMP __put_G3

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x34:
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	SBIW R26,4
	STD  Y+14,R26
	STD  Y+14+1,R27
	ADIW R26,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x35:
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	RJMP __put_G3

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x36:
	RCALL __GETD1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x37:
	RCALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x38:
	RCALL __ADDW2R15
	RCALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x39:
	ST   -Y,R30
	RJMP __lcd_write_data

	.equ __i2c_dir=__i2c_port-1
	.equ __i2c_pin=__i2c_port-2
_i2c_init:
	cbi  __i2c_port,__scl_bit
	cbi  __i2c_port,__sda_bit
	sbi  __i2c_dir,__scl_bit
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_delay2
_i2c_start:
	cbi  __i2c_dir,__sda_bit
	cbi  __i2c_dir,__scl_bit
	clr  r30
	nop
	sbis __i2c_pin,__sda_bit
	ret
	sbis __i2c_pin,__scl_bit
	ret
	rcall __i2c_delay1
	sbi  __i2c_dir,__sda_bit
	rcall __i2c_delay1
	sbi  __i2c_dir,__scl_bit
	ldi  r30,1
__i2c_delay1:
	ldi  r22,7
	rjmp __i2c_delay2l
_i2c_stop:
	sbi  __i2c_dir,__sda_bit
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__sda_bit
__i2c_delay2:
	ldi  r22,13
__i2c_delay2l:
	dec  r22
	brne __i2c_delay2l
	ret
_i2c_read:
	ldi  r23,8
__i2c_read0:
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	clc
	sbic __i2c_pin,__sda_bit
	sec
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	rol  r30
	dec  r23
	brne __i2c_read0
	ld   r23,y+
	tst  r23
	brne __i2c_read1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_read2
__i2c_read1:
	sbi  __i2c_dir,__sda_bit
__i2c_read2:
	rcall __i2c_delay1
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_delay1

_i2c_write:
	ld   r30,y+
	ldi  r23,8
__i2c_write0:
	lsl  r30
	brcc __i2c_write1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_write2
__i2c_write1:
	sbi  __i2c_dir,__sda_bit
__i2c_write2:
	rcall __i2c_delay2
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	sbi  __i2c_dir,__scl_bit
	dec  r23
	brne __i2c_write0
	cbi  __i2c_dir,__sda_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	ldi  r30,1
	sbic __i2c_pin,__sda_bit
	clr  r30
	sbi  __i2c_dir,__scl_bit
	ret

_strlen:
	ld   r26,y+
	ld   r27,y+
	clr  r30
	clr  r31
__strlen0:
	ld   r22,x+
	tst  r22
	breq __strlen1
	adiw r30,1
	rjmp __strlen0
__strlen1:
	ret

_strlenf:
	clr  r26
	clr  r27
	ld   r30,y+
	ld   r31,y+
__strlenf0:
	lpm 
	tst  r0
	breq __strlenf1
	adiw r26,1
	adiw r30,1
	rjmp __strlenf0
__strlenf1:
	mov  r30,r26
	mov  r31,r27
	ret

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x3E8
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__SAVEISR:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R0,SREG
	ST   -Y,R0
	RET

__LOADISR:
	LD   R0,Y+
	OUT  SREG,R0
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RET

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ANEGW1:
	COM  R30
	COM  R31
	ADIW R30,1
	RET

__LSLW3:
	LSL  R30
	ROL  R31
__LSLW2:
	LSL  R30
	ROL  R31
	LSL  R30
	ROL  R31
	RET

__MULW12U:
	MOV  R0,R26
	MOV  R1,R27
	LDI  R24,17
	CLR  R26
	SUB  R27,R27
	RJMP __MULW12U1
__MULW12U3:
	BRCC __MULW12U2
	ADD  R26,R0
	ADC  R27,R1
__MULW12U2:
	LSR  R27
	ROR  R26
__MULW12U1:
	ROR  R31
	ROR  R30
	DEC  R24
	BRNE __MULW12U3
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETD1P:
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X
	SBIW R26,3
	RET

__PUTWP1:
	ST   X+,R30
	ST   X,R31
	RET

__GETW1PF:
	LPM
	ADIW R30,1
	MOV  R1,R0
	LPM 
	MOV  R31,R0
	MOV  R30,R1
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

