
;CodeVisionAVR C Compiler V1.24.8a Evaluation
;(C) Copyright 1998-2006 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : AT90S8535
;Clock frequency        : 4,000000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External SRAM size     : 0
;Data Stack size        : 128 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : No
;char is unsigned       : Yes
;8 bit enums            : Yes
;Word align FLASH struct: Yes
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME AT90S8535
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 512
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x40
	.EQU __sm_mask=0x30
	.EQU __sm_powerdown=0x20

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOV  R30,R0
	MOV  R31,R1
	.ENDM

	.MACRO __GETB2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOV  R26,R0
	MOV  R27,R1
	.ENDM

	.MACRO __GETBRSX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "asc.vec"
	.INCLUDE "asc.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x200)
	LDI  R25,HIGH(0x200)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM
	ADIW R30,1
	MOV  R24,R0
	LPM
	ADIW R30,1
	MOV  R25,R0
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM
	ADIW R30,1
	MOV  R26,R0
	LPM
	ADIW R30,1
	MOV  R27,R0
	LPM
	ADIW R30,1
	MOV  R1,R0
	LPM
	ADIW R30,1
	MOV  R22,R30
	MOV  R23,R31
	MOV  R31,R0
	MOV  R30,R1
__GLOBAL_INI_LOOP:
	LPM
	ADIW R30,1
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOV  R30,R22
	MOV  R31,R23
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x25F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x25F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0xE0)
	LDI  R29,HIGH(0xE0)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0xE0
;       1 /*********************************************
;       2 This program was produced by the
;       3 CodeWizardAVR V1.24.0 Light
;       4 Automatic Program Generator
;       5  Copyright 1998-2003 HP InfoTech s.r.l.
;       6 http://www.hpinfotech.ro
;       7 e-mail:office@hpinfotech.ro
;       8 
;       9 Project : PPE Ascenseur 2006/2007
;      10 Version : 0.2
;      11 Date    : 19/02/2007
;      12 Author  : TOUZET / PETITJEAN / MOREUX
;      13 Company : Lycee Pierre-Emile MARTIN
;      14 Comments: 
;      15 Programme PPE Ascenseur
;      16 2006 / 2007
;      17 
;      18 
;      19 Chip type           : AT90S8535
;      20 Clock frequency     : 4,000000 MHz
;      21 Memory model        : Small
;      22 External SRAM size  : 0
;      23 Data Stack size     : 128
;      24 *********************************************/
;      25 
;      26 // Chargement des librairies
;      27 #include <90s8535.h>    // librairie C ATMEL AT90S8535
;      28 #include <delay.h>      // Fonction delai
;      29 #include <ssi.h> 	// SP de dcodage de la trame issue du clavier PS2 et SP Afficheur LCD
;      30 #include <stdio.h>	// Fonctions standard entres / sorties
;      31 
;      32 // I2C Bus functions
;      33 #asm
;      34    .equ __i2c_port=0x12
   .equ __i2c_port=0x12
;      35    .equ __sda_bit=3
   .equ __sda_bit=3
;      36    .equ __scl_bit=7
   .equ __scl_bit=7
;      37 #endasm
;      38 #include <i2c.h>
;      39 
;      40 // Afficheur LCD
;      41 #asm
;      42    .equ __lcd_port=0x15
   .equ __lcd_port=0x15
;      43 #endasm
;      44 #include <lcd.h>
;      45 
;      46 /*--------------------------------------------------------------------------------------------------------------------------
;      47 type 			Dsignation				      Commentaires		       
;      48 ----------------------------------------------------------------------------------------------------------------------------*/ 
;      49 char display_buffer_ligne0[17]; 	   // tampon ligne 0 de l'afficheur
_display_buffer_ligne0:
	.BYTE 0x11
;      50 char display_buffer_ligne1[17]; 	   // tampon ligne 1 de l'afficheur
_display_buffer_ligne1:
	.BYTE 0x11
;      51 char display_buffer_ligne2[17]; 	   // tampon ligne 2 de l'afficheur
_display_buffer_ligne2:
	.BYTE 0x11
;      52 char display_buffer_ligne3[17]; 	   // tampon ligne 3 de l'afficheur
_display_buffer_ligne3:
	.BYTE 0x11
;      53 //unsigned char EL1, EL2, EL3;		   // Etat des lectro-aimants
;      54 
;      55 // Programme d'interruption
;      56 interrupt [EXT_INT0] void ext_int0_isr(void)
;      57 {

	.CSEG
_ext_int0_isr:
;      58 //interrption INT0  cabler entre la carte SSI et la carte interface I2C
;      59 }
	RETI
;      60 
;      61 // Adresse CGRAM de l'afficheur LCD
;      62 #define Add_Caract0_CGRAM 0x40             //caractre 0
;      63 #define Add_Caract1_CGRAM 0x48		   //caractre 1
;      64 #define Add_Caract2_CGRAM 0x50             //caractre 2
;      65 #define Add_Caract3_CGRAM 0x58             //caractre 3
;      66 #define Add_Caract4_CGRAM 0x60             //caractre 4
;      67 #define Add_Caract5_CGRAM 0x68             //caractre 5
;      68 #define Add_Caract6_CGRAM 0x70             //caractre 6
;      69 #define Add_Caract7_CGRAM 0x78             //caractre 7
;      70 
;      71 // Adresses des Ports I2C
;      72 #define AD_BASE_PCF8574		0x40       // base I2C
;      73 #define AD_I2C_PORTA		0          // port A
;      74 #define AD_I2C_PORTB		1          // port B
;      75 #define AD_I2C_PORTC		2	   // port C
;      76 #define AD_I2C_PORTD		3          // port D
;      77 
;      78 // Adresses des ports I2C
;      79 #define I2C_PORTA 0
;      80 #define I2C_PORTB 1
;      81 #define I2C_PORTC 2
;      82 #define I2C_PORTD 3
;      83 
;      84 // Etat du graphe
;      85 #define test_1	  0
;      86 #define	test_2	  1
;      87 #define test_3    2
;      88 #define test_4    5
;      89 
;      90 // Prototype des fonctions :
;      91 void Ecrire_PCF8574(unsigned char add, unsigned char valeur);
;      92 void init_CGRAM(char valeur[8][8]);
;      93 unsigned char Lire_PCF8574(unsigned char add);
;      94 
;      95 // Caractres personnaliss placs dans la mmoire CGRAM du LCD
;      96 
;      97 // Caractre n1 : ATTENTION :
;      98 //---------------------------
;      99 const unsigned char attention[8][8] = {{0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x01}, // @0 CGRAM
;     100 {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x01},        // @1 CGRAM
;     101 {0x02, 0x02, 0x04, 0x05, 0x09, 0x09, 0x11, 0x11},        // @2 CGRAM
;     102 {0x08, 0x08, 0x04, 0x14, 0x12, 0x12, 0x11, 0x11},        // @3 CGRAM
;     103 {0x01, 0x01, 0x02, 0x02, 0x04, 0x04, 0x08, 0x0f},        // @4 CGRAM
;     104 {0x01, 0x01, 0x01, 0x00, 0x01, 0x01, 0x00, 0x1f},        // @5 CGRAM
;     105 {0x10, 0x10, 0x10, 0x00, 0x10, 0x10, 0x00, 0x1f},        // @6 CGRAM
;     106 {0x10, 0x10, 0x08, 0x08, 0x04, 0x04, 0x02, 0x1e}};       // @7 CGRAM                
;     107 
;     108 void main(void)
;     109 {
_main:
;     110 /*--------------------------------------------------------------------------------------------------------------
;     111 type 			Dsignation				      Commentaires		       
;     112 --------------------------------------------------------------------------------------------------------------*/
;     113 unsigned char etat,OCR1AL,OCR1BL;
;     114 unsigned char PO1,PO2,PO3;
;     115 unsigned char PC1,PC2,PC3;
;     116 unsigned char AP1,AP2,AP3;
;     117 unsigned char AC1,AC2,AC3;
;     118 unsigned char VP1,VP2,VP3;
;     119 //unsigned char LED1,LED2,LED3;
;     120 //unsigned char DEF;
;     121 //unsigned char coef;
;     122 unsigned char EtatPORTA,EtatPORTB,EtatPORTC,EtatPORTD; 
;     123 
;     124 // Port A initialization
;     125 PORTA=0x00;
	SBIW R28,16
;	etat -> R16
;	OCR1AL -> R17
;	OCR1BL -> R18
;	PO1 -> R19
;	PO2 -> R20
;	PO3 -> R21
;	PC1 -> Y+15
;	PC2 -> Y+14
;	PC3 -> Y+13
;	AP1 -> Y+12
;	AP2 -> Y+11
;	AP3 -> Y+10
;	AC1 -> Y+9
;	AC2 -> Y+8
;	AC3 -> Y+7
;	VP1 -> Y+6
;	VP2 -> Y+5
;	VP3 -> Y+4
;	EtatPORTA -> Y+3
;	EtatPORTB -> Y+2
;	EtatPORTC -> Y+1
;	EtatPORTD -> Y+0
	LDI  R30,LOW(0)
	OUT  0x1B,R30
;     126 DDRA=0x00;
	OUT  0x1A,R30
;     127 
;     128 // Port B initialization
;     129 PORTB=0x00;
	OUT  0x18,R30
;     130 DDRB=0x00;
	OUT  0x17,R30
;     131 
;     132 // Port C initialization
;     133 PORTC=0x00;
	OUT  0x15,R30
;     134 DDRC=0x00;
	OUT  0x14,R30
;     135 
;     136 // Port D initialization
;     137 PORTD=0x00;
	OUT  0x12,R30
;     138 DDRD=0xFF;
	LDI  R30,LOW(255)
	OUT  0x11,R30
;     139 
;     140 // Timer/Counter 0 initialization
;     141 TCCR0=0x00;
	LDI  R30,LOW(0)
	OUT  0x33,R30
;     142 TCNT0=0x00;
	OUT  0x32,R30
;     143 
;     144 // Timer/Counter 1 initialization
;     145 TCCR1A=0xA1;
	LDI  R30,LOW(161)
	OUT  0x2F,R30
;     146 TCCR1B=0x04;
	LDI  R30,LOW(4)
	OUT  0x2E,R30
;     147 TCNT1H=0x00;
	LDI  R30,LOW(0)
	OUT  0x2D,R30
;     148 TCNT1L=0x00;
	OUT  0x2C,R30
;     149 OCR1AH=0x00;
	OUT  0x2B,R30
;     150 OCR1AL=0x00;
	RCALL SUBOPT_0x0
;     151 OCR1BH=0x00;
	LDI  R30,LOW(0)
	OUT  0x29,R30
;     152 OCR1BL=0x00;
	LDI  R18,LOW(0)
;     153 
;     154 // Timer/Counter 2 initialization
;     155 ASSR=0x00;
	OUT  0x22,R30
;     156 TCCR2=0x00;
	OUT  0x25,R30
;     157 TCNT2=0x00;
	OUT  0x24,R30
;     158 OCR2=0x00;
	OUT  0x23,R30
;     159 
;     160 // External Interrupt(s) initialization
;     161 GIMSK=0x40;
	LDI  R30,LOW(64)
	OUT  0x3B,R30
;     162 MCUCR=0x03;
	LDI  R30,LOW(3)
	OUT  0x35,R30
;     163 GIFR=0x40;
	LDI  R30,LOW(64)
	OUT  0x3A,R30
;     164 
;     165 // Timer(s)/Counter(s) Interrupt(s) initialization
;     166 TIMSK=0x00;
	LDI  R30,LOW(0)
	OUT  0x39,R30
;     167 
;     168 // Analog Comparator initialization
;     169 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
;     170 
;     171 // I2C Bus initialisation
;     172 i2c_init();
	RCALL _i2c_init
;     173 
;     174 // LCD module initialisation
;     175 //lcd_init(20);        
;     176 
;     177 // Global enable interrupts
;     178 #asm("sei")
	sei
;     179 
;     180 // initialisation :
;     181 
;     182 {
;     183 sprintf(display_buffer_ligne0,"   PPE ascenseur");
	RCALL SUBOPT_0x1
	__POINTW1FN _0,0
	RCALL SUBOPT_0x2
;     184 sprintf(display_buffer_ligne1,"    2006 / 2007");
	RCALL SUBOPT_0x3
	__POINTW1FN _0,17
	RCALL SUBOPT_0x2
;     185 sprintf(display_buffer_ligne2,"     Carte SSI");
	RCALL SUBOPT_0x4
	__POINTW1FN _0,33
	RCALL SUBOPT_0x2
;     186 sprintf(display_buffer_ligne3,"  Lyce P-E MARTIN");
	RCALL SUBOPT_0x5
	__POINTW1FN _0,48
	RCALL SUBOPT_0x2
;     187 Affiche_LCD440(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2,display_buffer_ligne3);
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x3
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x5
	RCALL _Affiche_LCD440
;     188 delay_ms(4000);
	LDI  R30,LOW(4000)
	LDI  R31,HIGH(4000)
	RCALL SUBOPT_0x6
;     189 
;     190 etat=test_1;
	RCALL SUBOPT_0x7
;     191 }
;     192 
;     193 //fin initialisation
;     194 
;     195 while (1)
_0x3:
;     196       {
;     197       switch (etat)
	MOV  R30,R16
;     198       {
;     199       case test_1 : init_CGRAM(attention);
	CPI  R30,0
	BRNE _0x9
	LDI  R30,LOW(_attention*2)
	LDI  R31,HIGH(_attention*2)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _init_CGRAM
;     200                     lcd_gotoxy(17,0);		// caractre perso (ATTENTION) ligne 0
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0x9
	RCALL _lcd_gotoxy
;     201 		    lcd_putchar(0);
	RCALL SUBOPT_0x9
	RCALL SUBOPT_0xA
;     202 		    lcd_gotoxy(18,0);
	RCALL SUBOPT_0x9
	RCALL _lcd_gotoxy
;     203 		    lcd_putchar(1);
	RCALL SUBOPT_0xB
	RCALL SUBOPT_0xC
;     204 		    lcd_gotoxy(17,1);           // caractre perso (ATTENTION) ligne 1
	RCALL SUBOPT_0xB
	RCALL _lcd_gotoxy
;     205 		    lcd_putchar(2);
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0xA
;     206 		    lcd_gotoxy(18,1);
	RCALL SUBOPT_0xB
	RCALL _lcd_gotoxy
;     207 		    lcd_putchar(3);
	RCALL SUBOPT_0xE
	RCALL _lcd_putchar
;     208 		    lcd_gotoxy(16,2);           // caractre perso (ATTENTION) ligne 2
	LDI  R30,LOW(16)
	RCALL SUBOPT_0xF
	RCALL _lcd_gotoxy
;     209 		    lcd_putchar(4);
	LDI  R30,LOW(4)
	ST   -Y,R30
	RCALL SUBOPT_0xC
;     210 		    lcd_gotoxy(17,2);
	RCALL SUBOPT_0xD
	RCALL _lcd_gotoxy
;     211 		    lcd_putchar(5);
	LDI  R30,LOW(5)
	ST   -Y,R30
	RCALL SUBOPT_0xA
;     212 		    lcd_gotoxy(18,2);
	RCALL SUBOPT_0xD
	RCALL _lcd_gotoxy
;     213 		    lcd_putchar(6);
	LDI  R30,LOW(6)
	RCALL SUBOPT_0x10
;     214 		    lcd_gotoxy(19,2);
	LDI  R30,LOW(19)
	RCALL SUBOPT_0xF
	RCALL _lcd_gotoxy
;     215 		    lcd_putchar(7);              
	LDI  R30,LOW(7)
	RCALL SUBOPT_0x10
;     216 		    lcd_gotoxy(1,2);		// affichage de l'tat du test
	RCALL SUBOPT_0xB
	RCALL SUBOPT_0xD
	RCALL _lcd_gotoxy
;     217 		    lcd_putchar(etat);
	ST   -Y,R16
	RCALL _lcd_putchar
;     218 		    EtatPORTD=EtatPORTD | 0b00000001;		// DEF = 1
	RCALL SUBOPT_0x11
;     219       		    Ecrire_PCF8574(I2C_PORTD,EtatPORTD);
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x12
;     220       		    
;     221       		    if (AC1 == 1) etat=test_2;
	RCALL SUBOPT_0x13
	BRNE _0xA
	RCALL SUBOPT_0x14
;     222       		    if (AC2 == 1) etat=test_3;
_0xA:
	RCALL SUBOPT_0x15
	BRNE _0xB
	RCALL SUBOPT_0x16
;     223       		    if (AC3 == 1) etat=test_4;
_0xB:
	RCALL SUBOPT_0x17
	BRNE _0xC
	RCALL SUBOPT_0x18
;     224       		    	else etat=test_1;
	RJMP _0xD
_0xC:
	RCALL SUBOPT_0x7
;     225       break;
_0xD:
	RJMP _0x8
;     226       
;     227       case test_2 :
_0x9:
	CPI  R30,LOW(0x1)
	BRNE _0xE
;     228       	     if (AC1 == 1)
	RCALL SUBOPT_0x13
	BRNE _0xF
;     229 	      	{
;     230       		sprintf(display_buffer_ligne0,"AC1=1");
	RCALL SUBOPT_0x1
	__POINTW1FN _0,67
	RCALL SUBOPT_0x2
;     231        		sprintf(display_buffer_ligne1,"bouton enfonc");       
	RCALL SUBOPT_0x3
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x2
;     232        		sprintf(display_buffer_ligne2,"");
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x1A
	RCALL SUBOPT_0x2
;     233       	 	sprintf(display_buffer_ligne3,"--> appel etage 1");
	RCALL SUBOPT_0x5
	__POINTW1FN _0,88
	RCALL SUBOPT_0x2
;     234        		Affiche_LCD440(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2,display_buffer_ligne3);
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x3
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x1B
;     235        		EtatPORTD=EtatPORTD | 0b00010000;            // LED1 = 1
	RCALL SUBOPT_0x1C
;     236        	        Ecrire_PCF8574(I2C_PORTD,EtatPORTD);
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x12
;     237         	}
;     238              else EtatPORTD=EtatPORTD & 0b11101111;          // LED1 = 0
	RJMP _0x10
_0xF:
	RCALL SUBOPT_0x1D
;     239                   Ecrire_PCF8574(I2C_PORTD,EtatPORTD);
_0x10:
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x12
;     240       	     
;     241       	     if (AC2 == 1) etat=test_3;
	RCALL SUBOPT_0x15
	BRNE _0x11
	RCALL SUBOPT_0x16
;     242       	     if (AC3 == 1) etat=test_4;
_0x11:
	RCALL SUBOPT_0x17
	BRNE _0x12
	RCALL SUBOPT_0x18
;     243       	      	else etat=test_2;
	RJMP _0x13
_0x12:
	RCALL SUBOPT_0x14
;     244                     
;     245       break;
_0x13:
	RJMP _0x8
;     246       
;     247       case test_3 :
_0xE:
	CPI  R30,LOW(0x2)
	BRNE _0x14
;     248       	     if (AC2 == 1)
	RCALL SUBOPT_0x15
	BRNE _0x15
;     249 	      	{
;     250       		sprintf(display_buffer_ligne0,"AC2=1");
	RCALL SUBOPT_0x1
	__POINTW1FN _0,106
	RCALL SUBOPT_0x2
;     251        		sprintf(display_buffer_ligne1,"bouton enfonc");       
	RCALL SUBOPT_0x3
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x2
;     252        		sprintf(display_buffer_ligne2,"");
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x1A
	RCALL SUBOPT_0x2
;     253       	 	sprintf(display_buffer_ligne3,"--> appel etage 2");
	RCALL SUBOPT_0x5
	__POINTW1FN _0,112
	RCALL SUBOPT_0x2
;     254        		Affiche_LCD440(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2,display_buffer_ligne3);
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x3
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x1B
;     255        		EtatPORTD=EtatPORTD | 0b00100000;            // LED2 = 1
	RCALL SUBOPT_0x1E
;     256        	        Ecrire_PCF8574(I2C_PORTD,EtatPORTD);
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x12
;     257         	}
;     258              else EtatPORTD=EtatPORTD & 0b11011111;	     // LED2 = 0
	RJMP _0x16
_0x15:
	RCALL SUBOPT_0x1F
;     259                   Ecrire_PCF8574(I2C_PORTD,EtatPORTD);
_0x16:
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x12
;     260              
;     261              if (AC1 == 1) etat=test_2;
	RCALL SUBOPT_0x13
	BRNE _0x17
	RCALL SUBOPT_0x14
;     262       	     if (AC3 == 1) etat=test_4;
_0x17:
	RCALL SUBOPT_0x17
	BRNE _0x18
	RCALL SUBOPT_0x18
;     263       	      	else etat=test_3;
	RJMP _0x19
_0x18:
	RCALL SUBOPT_0x16
;     264                     
;     265       break;
_0x19:
	RJMP _0x8
;     266       
;     267       case test_4 :
_0x14:
	CPI  R30,LOW(0x5)
	BRNE _0x8
;     268       	     if (AC3 == 1)
	RCALL SUBOPT_0x17
	BRNE _0x1B
;     269 	      	{
;     270       		sprintf(display_buffer_ligne0,"AC3=1");
	RCALL SUBOPT_0x1
	__POINTW1FN _0,130
	RCALL SUBOPT_0x2
;     271        		sprintf(display_buffer_ligne1,"bouton enfonc");       
	RCALL SUBOPT_0x3
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x2
;     272        		sprintf(display_buffer_ligne2,"");
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x1A
	RCALL SUBOPT_0x2
;     273       	 	sprintf(display_buffer_ligne3,"--> appel etage 3");
	RCALL SUBOPT_0x5
	__POINTW1FN _0,136
	RCALL SUBOPT_0x2
;     274        		Affiche_LCD440(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2,display_buffer_ligne3);
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x3
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x1B
;     275        		EtatPORTD=EtatPORTD | 0b01000000;            // LED3 = 1
	RCALL SUBOPT_0x20
;     276        	        Ecrire_PCF8574(I2C_PORTD,EtatPORTD);
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x12
;     277         	}
;     278              else EtatPORTD=EtatPORTD & 0b10111111;	     // LED3 = 0
	RJMP _0x1C
_0x1B:
	RCALL SUBOPT_0x21
;     279                   Ecrire_PCF8574(I2C_PORTD,EtatPORTD);
_0x1C:
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x12
;     280              
;     281              if (AC1 == 1) etat=test_2;
	RCALL SUBOPT_0x13
	BRNE _0x1D
	RCALL SUBOPT_0x14
;     282       	     if (AC2 == 1) etat=test_3;
_0x1D:
	RCALL SUBOPT_0x15
	BRNE _0x1E
	RCALL SUBOPT_0x16
;     283       	      	else etat=test_4;
	RJMP _0x1F
_0x1E:
	RCALL SUBOPT_0x18
;     284                     
;     285       break;     
_0x1F:
;     286    }
_0x8:
;     287   };
	RJMP _0x3
;     288 
;     289 AP1 = (Lire_PCF8574(I2C_PORTA)&0b01000000);        // lecture PA6
;     290 AP2 = (Lire_PCF8574(I2C_PORTA)&0b10000000);        // lecture PA7
;     291 AP3 = (Lire_PCF8574(I2C_PORTB)&0b00000001);        // lecture PB0
;     292 AC1 = (Lire_PCF8574(I2C_PORTB)&0b00000010);        // lecture PB1
;     293 AC2 = (Lire_PCF8574(I2C_PORTB)&0b00000100);        // lecture PB2
;     294 AC3 = (Lire_PCF8574(I2C_PORTB)&0b00001000);        // lecture PB3
;     295 PO1 = (Lire_PCF8574(I2C_PORTA)&0b00001000);        // lecture PA3
;     296 PO2 = (Lire_PCF8574(I2C_PORTA)&0b00010000);        // lecture PA4
;     297 PO3 = (Lire_PCF8574(I2C_PORTA)&0b00100000);        // lecture PA5
;     298 VP1 = (Lire_PCF8574(I2C_PORTC)&0b00000001);        // lecture PC0
;     299 VP2 = (Lire_PCF8574(I2C_PORTC)&0b00000010);        // lecture PC1
;     300 VP3 = (Lire_PCF8574(I2C_PORTC)&0b00000100);        // lecture PC2
;     301 PC1 = (Lire_PCF8574(I2C_PORTA)&0b00000001);        // lecture PA0
;     302 PC2 = (Lire_PCF8574(I2C_PORTA)&0b00000010);        // lecture PA1
;     303 PC3 = (Lire_PCF8574(I2C_PORTA)&0b00000100);        // lecture PA2
;     304 
;     305 EtatPORTA = (Lire_PCF8574(I2C_PORTA));             // lecture du port A
;     306 EtatPORTB = (Lire_PCF8574(I2C_PORTB));             // Lecture du port B
;     307 EtatPORTC = (Lire_PCF8574(I2C_PORTC));             // Lecture du port C
;     308 EtatPORTD = (Lire_PCF8574(I2C_PORTD));             // Lecture du port D
;     309                                         
;     310 EtatPORTD=EtatPORTD | 0b00010000;	// LED1 = 1
;     311 EtatPORTD=EtatPORTD & 0b11101111;	// LED1 = 0		
;     312 
;     313 EtatPORTD=EtatPORTD | 0b00100000;	// LED2 = 1
;     314 EtatPORTD=EtatPORTD & 0b11011111;	// LED2 = 0
;     315                                        
;     316 EtatPORTD=EtatPORTD | 0b01000000;	// LED3 = 1
;     317 EtatPORTD=EtatPORTD & 0b10111111;	// LED3 = 0
;     318 
;     319 EtatPORTD=EtatPORTD | 0b00000010;	// EL1 = 1
;     320 EtatPORTD=EtatPORTD & 0b11111101;	// EL1 = 0
;     321 
;     322 EtatPORTD=EtatPORTD | 0b00000100;	// EL2 = 1
;     323 EtatPORTD=EtatPORTD & 0b11111011;	// EL2 = 0
;     324 
;     325 EtatPORTD=EtatPORTD | 0b00001000;	// EL3 = 1
;     326 EtatPORTD=EtatPORTD & 0b11110111;	// EL3 = 0
;     327 
;     328 EtatPORTD=EtatPORTD | 0b00000001;	// DEF = 1
;     329 EtatPORTD=EtatPORTD & 0b11111110;	// DEF = 0
;     330 
;     331 Ecrire_PCF8574(I2C_PORTD,EtatPORTD);
;     332 }
_0x20:
	RJMP _0x20
;     333 
;     334 //fin du programme principal
;     335 
;     336 
;     337 // Sous-programmes
;     338 //----------------
;     339     
;     340 unsigned char Lire_PCF8574(unsigned char add)          // Procdure de lecture du port I2C
;     341 {
_Lire_PCF8574:
;     342   unsigned char entrees;
;     343   i2c_start();
	ST   -Y,R16
;	add -> Y+1
;	entrees -> R16
	RCALL SUBOPT_0x27
;     344   i2c_write(0x41 | add << 1);
	ORI  R30,LOW(0x41)
	RCALL SUBOPT_0x28
;     345   entrees = i2c_read(0);
	RCALL SUBOPT_0x9
	RCALL _i2c_read
	MOV  R16,R30
;     346   i2c_stop();
	RCALL _i2c_stop
;     347   return entrees;    
	MOV  R30,R16
	LDD  R16,Y+0
	RJMP _0x27
;     348 } 
;     349 
;     350 
;     351 void Ecrire_PCF8574(unsigned char add, unsigned char valeur)           // Procdure d'criture sur le port I2C
;     352 {
_Ecrire_PCF8574:
;     353   i2c_start();
;	add -> Y+1
;	valeur -> Y+0
	RCALL SUBOPT_0x27
;     354   i2c_write(0x40 | add << 1);
	ORI  R30,0x40
	RCALL SUBOPT_0x28
;     355   i2c_write(valeur);
	LD   R30,Y
	RCALL SUBOPT_0x28
;     356   i2c_stop();
	RCALL _i2c_stop
;     357   delay_ms(10);
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL SUBOPT_0x6
;     358 } 
_0x27:
	ADIW R28,2
	RET
;     359 
;     360 /*
;     361 
;     362 void EL1_egal_1()
;     363 {
;     364 unsigned char EtatPORTD;
;     365 EtatPORTD=EtatPORTD | 0b00000010;	//EL1=1 
;     366 Ecrire_PCF8574(PORTD,EtatPORTD); 	//EL1=1;
;     367 }         
;     368  
;     369 */
;     370 
;     371 
;     372 void init_CGRAM(char valeur[8][8])
;     373  {
_init_CGRAM:
;     374  unsigned char i,j;
;     375  for (i=0;i<8;i++)
	RCALL __SAVELOCR2
;	valeur -> Y+2
;	i -> R16
;	j -> R17
	RCALL SUBOPT_0x7
_0x22:
	CPI  R16,8
	BRSH _0x23
;     376   {
;     377    for (j=0;j<8;j++)
	RCALL SUBOPT_0x0
_0x25:
	CPI  R17,8
	BRSH _0x26
;     378    	lcd_write_byte(Add_Caract0_CGRAM + i, valeur[i][j]);
	MOV  R30,R16
	SUBI R30,-LOW(64)
	ST   -Y,R30
	MOV  R30,R16
	LDI  R31,0
	LDD  R26,Y+3
	LDD  R27,Y+3+1
	RCALL __LSLW3
	ADD  R26,R30
	ADC  R27,R31
	MOV  R30,R17
	LDI  R31,0
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	ST   -Y,R30
	RCALL _lcd_write_byte
;     379     }
	SUBI R17,-1
	RJMP _0x25
_0x26:
	SUBI R16,-1
	RJMP _0x22
_0x23:
;     380  }
	RCALL __LOADLOCR2
	ADIW R28,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x0:
	LDI  R17,LOW(0)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES
SUBOPT_0x1:
	LDI  R30,LOW(_display_buffer_ligne0)
	LDI  R31,HIGH(_display_buffer_ligne0)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 16 TIMES
SUBOPT_0x2:
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL _sprintf
	ADIW R28,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES
SUBOPT_0x3:
	LDI  R30,LOW(_display_buffer_ligne1)
	LDI  R31,HIGH(_display_buffer_ligne1)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES
SUBOPT_0x4:
	LDI  R30,LOW(_display_buffer_ligne2)
	LDI  R31,HIGH(_display_buffer_ligne2)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES
SUBOPT_0x5:
	LDI  R30,LOW(_display_buffer_ligne3)
	LDI  R31,HIGH(_display_buffer_ligne3)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x6:
	ST   -Y,R31
	ST   -Y,R30
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x7:
	LDI  R16,LOW(0)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x8:
	LDI  R30,LOW(17)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 13 TIMES
SUBOPT_0x9:
	LDI  R30,LOW(0)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0xA:
	RCALL _lcd_putchar
	LDI  R30,LOW(18)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES
SUBOPT_0xB:
	LDI  R30,LOW(1)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xC:
	RCALL _lcd_putchar
	RJMP SUBOPT_0x8

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES
SUBOPT_0xD:
	LDI  R30,LOW(2)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES
SUBOPT_0xE:
	LDI  R30,LOW(3)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xF:
	ST   -Y,R30
	RJMP SUBOPT_0xD

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x10:
	ST   -Y,R30
	RJMP _lcd_putchar

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x11:
	LD   R30,Y
	ORI  R30,1
	ST   Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES
SUBOPT_0x12:
	LDD  R30,Y+1
	ST   -Y,R30
	RJMP _Ecrire_PCF8574

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x13:
	LDD  R26,Y+9
	CPI  R26,LOW(0x1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x14:
	LDI  R16,LOW(1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x15:
	LDD  R26,Y+8
	CPI  R26,LOW(0x1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x16:
	LDI  R16,LOW(2)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x17:
	LDD  R26,Y+7
	CPI  R26,LOW(0x1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x18:
	LDI  R16,LOW(5)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x19:
	__POINTW1FN _0,73
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x1A:
	__POINTW1FN _0,16
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x1B:
	RCALL _Affiche_LCD440
	LD   R30,Y
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1C:
	ORI  R30,0x10
	ST   Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1D:
	LD   R30,Y
	ANDI R30,0xEF
	ST   Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1E:
	ORI  R30,0x20
	ST   Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1F:
	LD   R30,Y
	ANDI R30,0xDF
	ST   Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x20:
	ORI  R30,0x40
	ST   Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x21:
	LD   R30,Y
	ANDI R30,0xBF
	ST   Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x22:
	RCALL _Lire_PCF8574
	ANDI R30,LOW(0x1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x23:
	RCALL _Lire_PCF8574
	ANDI R30,LOW(0x2)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x24:
	RCALL _Lire_PCF8574
	ANDI R30,LOW(0x4)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x25:
	RCALL _Lire_PCF8574
	ANDI R30,LOW(0x8)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0x26:
	ST   Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x27:
	RCALL _i2c_start
	LDD  R30,Y+1
	LSL  R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x28:
	ST   -Y,R30
	RJMP _i2c_write

	.equ __i2c_dir=__i2c_port-1
	.equ __i2c_pin=__i2c_port-2
_i2c_init:
	cbi  __i2c_port,__scl_bit
	cbi  __i2c_port,__sda_bit
	sbi  __i2c_dir,__scl_bit
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_delay2
_i2c_start:
	cbi  __i2c_dir,__sda_bit
	cbi  __i2c_dir,__scl_bit
	clr  r30
	nop
	sbis __i2c_pin,__sda_bit
	ret
	sbis __i2c_pin,__scl_bit
	ret
	rcall __i2c_delay1
	sbi  __i2c_dir,__sda_bit
	rcall __i2c_delay1
	sbi  __i2c_dir,__scl_bit
	ldi  r30,1
__i2c_delay1:
	ldi  r22,7
	rjmp __i2c_delay2l
_i2c_stop:
	sbi  __i2c_dir,__sda_bit
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__sda_bit
__i2c_delay2:
	ldi  r22,13
__i2c_delay2l:
	dec  r22
	brne __i2c_delay2l
	ret
_i2c_read:
	ldi  r23,8
__i2c_read0:
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
__i2c_read3:
	sbis __i2c_pin,__scl_bit
	rjmp __i2c_read3
	rcall __i2c_delay1
	clc
	sbic __i2c_pin,__sda_bit
	sec
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	rol  r30
	dec  r23
	brne __i2c_read0
	ld   r23,y+
	tst  r23
	brne __i2c_read1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_read2
__i2c_read1:
	sbi  __i2c_dir,__sda_bit
__i2c_read2:
	rcall __i2c_delay1
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_delay1

_i2c_write:
	ld   r30,y+
	ldi  r23,8
__i2c_write0:
	lsl  r30
	brcc __i2c_write1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_write2
__i2c_write1:
	sbi  __i2c_dir,__sda_bit
__i2c_write2:
	rcall __i2c_delay2
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
__i2c_write3:
	sbis __i2c_pin,__scl_bit
	rjmp __i2c_write3
	rcall __i2c_delay1
	sbi  __i2c_dir,__scl_bit
	dec  r23
	brne __i2c_write0
	cbi  __i2c_dir,__sda_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	ldi  r30,1
	sbic __i2c_pin,__sda_bit
	clr  r30
	sbi  __i2c_dir,__scl_bit
	ret

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x3E8
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__LSLW3:
	LSL  R30
	ROL  R31
__LSLW2:
	LSL  R30
	ROL  R31
	LSL  R30
	ROL  R31
	RET

__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

;END OF CODE MARKER
__END_OF_CODE:
