/*********************************************
This program was produced by the
CodeWizardAVR V1.24.0 Standard
Automatic Program Generator
 Copyright 1998-2003 HP InfoTech s.r.l.
http://www.hpinfotech.ro
e-mail:office@hpinfotech.ro

Project : 
Version : 
Date    : 28/03/2007
Author  : edfde                           
Company :                                 
Comments: 


Chip type           : AT90S8535
Clock frequency     : 4,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 128
*********************************************/

#include <90s8535.h>
#include <ssi.h> 	// SP de dcodage de la trame issue du clavier PS2 et SP Afficheur LCD
#include <stdio.h>	// Fonctions standard entres / sorties

// Alphanumeric LCD Module functions
#asm
   .equ __lcd_port=0x15
#endasm
#include <lcd4x40.h>

// Adresse CGRAM de l'afficheur LCD
#define Add_Caract0_CGRAM 0x40             //caractre 0
#define Add_Caract1_CGRAM 0x48		   //caractre 1
#define Add_Caract2_CGRAM 0x50             //caractre 2
#define Add_Caract3_CGRAM 0x58             //caractre 3
#define Add_Caract4_CGRAM 0x60             //caractre 4
#define Add_Caract5_CGRAM 0x68             //caractre 5
#define Add_Caract6_CGRAM 0x70             //caractre 6
#define Add_Caract7_CGRAM 0x78             //caractre 7


// Declare your global variables here
/*--------------------------------------------------------------------------------------------------------------------------
type 			Dsignation				      Commentaires		       
----------------------------------------------------------------------------------------------------------------------------*/ 
char display_buffer_ligne0[17]; 	   // tampon ligne 0 de l'afficheur
char display_buffer_ligne1[17]; 	   // tampon ligne 1 de l'afficheur
char display_buffer_ligne2[17]; 	   // tampon ligne 2 de l'afficheur
char display_buffer_ligne3[17]; 	   // tampon ligne 3 de l'afficheur

// Caractre n1 : ATTENTION :
//---------------------------
const unsigned char attention[8][8] = {{0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x01}, // @0 CGRAM
{0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x01},        // @1 CGRAM
{0x02, 0x02, 0x04, 0x05, 0x09, 0x09, 0x11, 0x11},        // @2 CGRAM
{0x08, 0x08, 0x04, 0x14, 0x12, 0x12, 0x11, 0x11},        // @3 CGRAM
{0x01, 0x01, 0x02, 0x02, 0x04, 0x04, 0x08, 0x0f},        // @4 CGRAM
{0x01, 0x01, 0x01, 0x00, 0x01, 0x01, 0x00, 0x1f},        // @5 CGRAM
{0x10, 0x10, 0x10, 0x00, 0x10, 0x10, 0x00, 0x1f},        // @6 CGRAM
{0x10, 0x10, 0x08, 0x08, 0x04, 0x04, 0x02, 0x1e}};       // @7 CGRAM     

void main(void)
{
// Declare your local variables here


// LCD module initialization
lcd_init();


                     sprintf(display_buffer_ligne0,"Etage 1");
                     sprintf(display_buffer_ligne1,"");
                     sprintf(display_buffer_ligne2,"attente appel");
                     sprintf(display_buffer_ligne3,"porte 1 deverouillee");
                     Affiche_LCD440(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2,display_buffer_ligne3);


}
